/*======================================================*/
/*======================================================*/
/*	Seriespepito for pelisalacarta para WebTV	*/
/*======================================================*/
/*======================================================*/

if(DEBUG) log("Cargando plugin Seriespepito");

/************************/
/*	Define Plugin	*/
/************************/

var seriespepito={
	title: "Seriespepito",
	media: ["Series", seriespepito_configure_series],
	init:  [seriespepito_init_main,   seriespepito_init_search,   seriespepito_init_series,   seriespepito_init_seasons,   seriespepito_init_chapters,  seriespepito_init_versions],
	load:  [seriespepito_cargar_pagina],
	render:[seriespepito_render_main, seriespepito_render_search, seriespepito_render_series, seriespepito_render_seasons, seriespepito_render_chapters, seriespepito_render_versions],
	action:[seriespepito_action_main, seriespepito_action_search, seriespepito_action_series, seriespepito_action_seasons, seriespepito_action_chapters, seriespepito_action_versions],
	focus: [seriespepito_render_focus]
};

/********************************/
/*	START of Customization	*/
/********************************/

//Configura busquedas y mensajes para buscar series

function seriespepito_configure_series() {
	base_url = "http://www.seriespepito.com/";
	estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 99; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.seriespepito.com/"; // series
	search_categories = /<a href=[\"']\/(lista-series[^\/]*\/)[\"']>([^<]*)<\/a>/g; //series
	search_seasons = /<div class=\"nombre\">[^<]*<a href=\"(http:\/\/[^\.]*.seriespepito.com)\" title=\"[^\"]*\">([^<]*)<\/a>/g;
	search_chapters = /<a  href='(http:\/\/[^\.]*.seriespepito.com\/capitulos[^']*)' title='[^']*'><span>([^<]*)<\/span><\/a>/g; //series
	search_versions = /href='(http:\/\/www.megaupload.com\/[^']*)' target='_blank' rel='nofollow' alt=''>(Descargar)<\/a>/g; //series
	url_buscar = "http://www.seriespepito.com/buscador/?q="; //Series
	search_busqueda = /href='(http:\/\/[^\.]*.seriespepito.com)'>([^<]*)</g;
	url_novelties = "http://www.seriespepito.com/nuevos-capitulos/"; // series
                                   
	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_series = "<div class='message'></div>No hay series disponibles para esta categor&iacute;a.";
	no_matches_available_seasons = "<div class='message'></div>No hay temporadas disponibles para esta categor&iacute;a.";
	no_matches_available_chapters = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de series, un momento por favor";
	message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de series para ";
	log_loading_seasons = "Cargando la pantalla de temporadas para ";
	log_loading_chapters = "Cargando la pantalla de cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}


/************************/
/*	Main		*/
/************************/

var seriespepito_main_list;

//Initialize the behaviour of the main page

function seriespepito_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Razon: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			log(log_page_not_found);
			break;
	}
}

function seriespepito_search_error_callback() {
	log(log_error_analizing_data + current_url);
	v_loading=false;
}

function seriespepito_init_main(){
	//if(DEBUG) log ("Inicializando main");
	list_no_matches_available = no_matches_available_main;
	//Visitamos primero pa pagina de acceso por si hay alguna cookie o alguna medida de seguridad
	//HED.helpers.url({url: current_url = "http://www.cinetube.es/", matchlink: "http://*peliculas/*", cbok: function(data) {}});
	//La expresin regular de la siguiente linea es lo que selecciona las categorias. 
	//Se puede cambiar para que salgan clasificadas de otra forma, pero el orden alfabetico es 
	//la nica forma que he encontrado para que las listas salgan enteras en una pgina.
	//Si no sale todo en una pgina habra que complicar el resto de busquedas para que tnegan en cuenta las busquedas paginadas
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	HED.helpers.url({url: current_url = url_categories, match: match_current = search_categories, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if(DEBUG) log("Loaded main page");
		//if (this_loading_ref !== v_loading_ref) return;
		seriespepito_main_list =new Array();
		seriespepito_main_list.push({title: "Destacados", url: ""});
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) seriespepito_main_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		v_visible=14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriespepito_search_error_callback, cbmx: seriespepito_multiplexed_callback});
}

//Renderiza el men de categoras

function seriespepito_render_main() {
	list_render(seriespepito_main_list,"", "seriespepito_");
}

//What to do when OK is pressed under the main menu

function seriespepito_action_main() {
	//Destacados
	if ((v_screen_sel==0) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_buscar;
		cathegory_title_backup = "Destacados";
		//if (DEBUG) log(log_loading_series + cathegory_url_backup);
		season_return_backup="main";
		v_screen = "seasons";
	}
	else if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel-1})) !== false) {
		if ((cathegory_title_backup != v_screen_sel_data.title) || (!pages_left)) page_number = 0;
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) cathegory_url_backup = base_url + v_screen_sel_data.url; else cathegory_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) cathegory_title_backup = v_screen_sel_data.title; else cathegory_title_backup = "(descarga progresiva en curso)";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		if(estructura=="peliculas") {
			serie_return_backup="main";
			v_screen = "series";
		}
		if(estructura=="series") {
			season_return_backup="main";
			v_screen = "seasons";
		}
	}
}

/************************/
/*	Search		*/
/************************/

//Initialize the behaviour of the search page

function seriespepito_init_search(){};

//Renderiza el men de bsqueda

function seriespepito_render_search() {};

//What to do when OK is pressed under the search menu

function seriespepito_action_search() {};

/************************/
/*	Series		*/
/************************/

function seriespepito_cargar_pagina() {};

//Initialize the behaviour of the series page

function seriespepito_init_series(){};

//Renderiza el men de series (Con cartulas)

function seriespepito_render_series() {};

//What to do when OK is pressed under the series menu

function seriespepito_action_series() {};

/************************/
/*	Seasons		*/
/************************/

var seriespepito_seasons_list;

//Initialize the behaviour of the seasons page

function seriespepito_init_seasons(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	//if ((estructura == "series") && (cathegory_title_backup.search("Buscar: ")==-1)) var url_busqueda = cathegory_url_backup;
	//else var url_busqueda = serie_url_backup;

	var url_busqueda = cathegory_url_backup;
	if (cathegory_title_backup.search("Destacados")!=-1) var patron_busqueda = search_busqueda;
	else var patron_busqueda = search_seasons;
	log("URL: " + url_busqueda);

	HED.helpers.url({url: current_url = url_busqueda, match: match_current = patron_busqueda, cbok: function(data) {
		seriespepito_seasons_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) {
			seriespepito_seasons_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
			
		}
		//seriespepito_chapters_datos_imagen = HED.helpers.url({url: current_url, matchnames: ["image"], match: search_image, get: 0, cbmx: seriespepito_multiplexed_callback});
		//if (cathegory_title_backup.search("Buscar: ")!=-1) seriespepito_chapters_titulo = serie_title_backup;
		//else seriespepito_chapters_titulo = cathegory_title_backup;
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriespepito_search_error_callback, cbmx: seriespepito_multiplexed_callback});
}

//Renderiza el men de temporadas

function seriespepito_render_seasons() {
	list_render(seriespepito_seasons_list,"", "seriespepito_");
}

//What to do when OK is pressed under the seasons menu

function seriespepito_action_seasons() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) season_url_backup = v_screen_sel_data.url; else chapter_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) season_title_backup = v_screen_sel_data.title; else chapter_title_backup = cathegory_title_backup;
		if (DEBUG) log(log_loading_chapters + season_url_backup);
		v_screen = "chapters";
		chapter_return_backup="seasons";
	}
}


/************************/
/*	Chapters	*/
/************************/

//Initialize the behaviour of the chapters page


var seriespepito_chapters_list;

function seriespepito_init_chapters(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	//if ((estructura == "series") && (cathegory_title_backup.search("Buscar: ")==-1)) var url_busqueda = cathegory_url_backup;
	//else var url_busqueda = serie_url_backup;
	var url_busqueda=season_url_backup;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = search_chapters, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if (this_loading_ref !== v_loading_ref) return;
		seriespepito_chapters_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) seriespepito_chapters_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		//seriespepito_chapters_datos_imagen = HED.helpers.url({url: current_url, matchnames: ["image"], match: search_image, get: 0, cbmx: seriespepito_multiplexed_callback});
		//if (cathegory_title_backup.search("Buscar: ")!=-1) seriespepito_chapters_titulo = serie_title_backup;
		//else seriespepito_chapters_titulo = cathegory_title_backup;
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriespepito_search_error_callback, cbmx: seriespepito_multiplexed_callback});
}

//Renderiza el men de captulos

function seriespepito_render_chapters() {

	list_render(seriespepito_chapters_list,"", "seriespepito_");

}

//What to do when OK is pressed under the chapters menu

function seriespepito_action_chapters() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) chapter_url_backup = v_screen_sel_data.url; else chapter_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) chapter_title_backup = v_screen_sel_data.title; else chapter_title_backup = season_title_backup;
		if (DEBUG) log(log_loading_versions + chapter_url_backup);
		v_screen = "versions";
		version_return_backup="chapters";
	}
}

/************************/
/*	Versions	*/
/************************/

//Initialize the behaviour of the versions page

var seriespepito_versions_list;

function seriespepito_init_versions(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	var url_busqueda = chapter_url_backup;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = search_versions, cbok: function(data) {
		seriespepito_versions_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) {
			seriespepito_versions_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
			seriespepito_versions_list[i].title = "Ver desde Megaupload Mirror "+ (i+1);
		}
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriespepito_search_error_callback, cbmx: seriespepito_multiplexed_callback});
}

//Renderiza el men de captulos

function seriespepito_render_versions() {

	list_render(seriespepito_versions_list,"", "seriespepito_");

}

//What to do when OK is pressed under the chapters menu

function seriespepito_action_versions() {
	if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
	if ((v_screen_sel_data = HED.helpers.url({get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) {
			version_url_backup = v_screen_sel_data.url;
			megaupload_return_backup="versions";
			v_screen = "megaupload";
			if (domobj = document.getElementById("fields")) domobj.innerHTML = message_getting_information_versions; 
			if (domobj = document.getElementById("title")) domobj.innerHTML = message_getting_information_versions_title;
			if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
			if (v_screen != "megaupload") return;
			if (DEBUG) log("Reproducir " + v_screen_sel_data.url);
			play_handler(v_screen_sel_data.url);

		}
	}
}


/************************/
/*	Focus Handling	*/
/************************/

function seriespepito_render_focus() {
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});	
	if(v_screen=="main") maximum+=2;
	if((v_screen == "series") && pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}
	if (v_screen=="search") { 
		//if (DEBUG) log("pagina de busqueda, renderizando foco");
		if (domobj = document.getElementById("write_here")) {
			//if (DEBUG) log("div encontrado");
			domobj.focus();
		}
		else {
			//if (DEBUG) log("no he encontrado el div");
		}
	}
	else {
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel - v_screen_ofs);
		}
	}

	var titulo = "";

	switch (v_screen) {
		case "main":
			if (maximum > 0) titulo = media_title_backup + " / " + "Alfab&eacute;tico " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = media_title_backup + " / " + "Alfab&eacute;tico";
			break;
		case "search":
			titulo = media_title_backup + " / " +"Buscar " + text_to_search;
			break;
		case "series":
			if(pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / ---";
			if(!pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = cathegory_title_backup;
			break;
		case "seasons":
			if (maximum > 0) titulo = media_title_backup + " / " + cathegory_title_backup + " / Series disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "chapters":
			if (maximum > 0) titulo = media_title_backup + " / " + cathegory_title_backup + " / " + season_title_backup + " / Cap&iacute;tulos disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "versions":
			if (maximum > 0) titulo = media_title_backup + " / " + cathegory_title_backup + " / " + season_title_backup + " / " + chapter_title_backup + " / Versiones disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
	}
	if (titulo.length>70) titulo = "..." + titulo.slice(titulo.length-70);
	if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
}