/*======================================================*/
/*======================================================*/
/*	Seriesyonkis for pelisalacarta para WebTV	*/
/*======================================================*/
/*======================================================*/

if(DEBUG) log("Cargando plugin Seriesyonkis");

/************************/
/*	Define Plugin	*/
/************************/

var seriesyonkis={
	title: "SeriesYonkis",
	media: ["Series", seriesyonkis_configure_series, "Pel&iacute;culas", seriesyonkis_configure_peliculas],
	init:  [seriesyonkis_init_main,   seriesyonkis_init_search,   seriesyonkis_init_series,   seriesyonkis_init_seasons,   seriesyonkis_init_chapters,  seriesyonkis_init_versions],
	load:  [],
	render:[seriesyonkis_render_main, seriesyonkis_render_search, seriesyonkis_render_series, seriesyonkis_render_seasons, seriesyonkis_render_chapters, seriesyonkis_render_versions],
	action:[seriesyonkis_action_main, seriesyonkis_action_search, seriesyonkis_action_series, seriesyonkis_action_seasons, seriesyonkis_action_chapters, seriesyonkis_action_versions],
	focus: [seriesyonkis_render_focus]
};

/********************************/
/*	START of Customization	*/
/********************************/

//Configura busquedas y mensajes para buscar series

function seriesyonkis_configure_series() {
	base_url = "http://www.seriesyonkis.com/";
	estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 50; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.seriesyonkis.com/"; // series
	search_categories = /\"http:\/\/www.seriesyonkis.com\/(serie[^\"]*)\"[^>]*>([^<]*)</g; // series
	url_novelties = "http://www.seriesyonkis.com/ultimos-capitulos.php"; // series
	search_novelties = /<div class=\"ficha\" style=\"background:url\(([^\)]*)\)[^\"]*\"><a title=\"[^\"]*\" href=\"http:\/\/www.seriesyonkis.com\/([^\"]*)\">([^<]*)<\/a><br \/><br \/>/g;//series
	//search_link_pages = /<a href='http:\/\/www.seriesyonkis.com\/genero(\/[^']*)'>([^<]*)<\/a>/g; // peliculas
	search_series = /<li><a href=\"http:\/\/www.seriesyonkis.com\/(serie\/[^\"]*)\" title=\"[^\"]*\"><img height=\"84\" src=\"(http:\/\/s.staticyonkis.com\/images\/[^\"]*)\" alt=\"[^\"]*\" align=\"right\" \/><div align=\"left\"><strong>([^<]*)<\/strong>/g; //series
	search_chapters = /<a href=\"http:\/\/www.seriesyonkis.com\/(capitulo\/[^\"]*)\" title="[^\"]*\">([^<]*)<\/a>/g; //series
	search_versions = /<a href=\"http:\/\/www.seriesyonkis.com\/(go\/d\/[^\"]*)\" title="Descargar archivo" target='_blank'>(DESCARGAR DE megaupload)<\/a>/g; //series
	//search_brief = /<br \/>([^-]*)- [^\"]*\"page-links\"><\/div><div class=\"footeritems\">/g;
	search_brief1 = /<h3>Descripcion:<\/h3>([^<]*)<br \/>/g; //series


	search_brief = /<h3>Descripcion:<\/h3>(.*)<div class=\"page-links\"><\/div><div class=\"footeritems\">/g; //series





	search_image = /<p><h3>Serie:<\/h3><img title=\"[^\"]*\" src=\"(http:\/\/s.staticyonkis.com\/images\/[^\"]*)\"/g; //Peliculas
	//search_link_pages = /<li class=\"pagina\"><a href=\"(\/series[^\"]*)\">([^<]*)<\/a><\/li>/g; // series
	//search_series = /<li>[^<]*<a href=\"\/(series\/[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"peli\" \/>[^_]*_lg\">[^_]*_ficha\">([^<]*)<\/p>/g; // series 
	//search_versions = /<div class=\"tit_opts\"><a href=\"\/(series\/descargar[^\"]*)\" target=\"_BLANK\">[^<]*<p>([^<]*)<span class=\"bold\"><\/span><\/p>[^<]*<p><span>([^<]*)<\/span><\/p>[^<]*<p class=\"v_ico\"><img src=\"http:\/\/caratulas.cinetube.es\/img\/cont\/megaupload.png\" alt=\"Megaupload\"/g; //series
	//search_brief = /<h3 class=\"tit_cent\">Ficha de la serie<\/h3>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^<]*<p>([^<]*)<\/p>/g; //series
	//search_seasons = /<li><h2><a href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/h2><span><[^>]*>([^\|]*)\|/g; // series
	//search_chapters = /<div class=\"title\"> <a class=\"bold\" href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/div>/g; //series
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // series

	url_buscar = "http://www.seriesyonkis.com/buscarSerie.php?s="; //Series

	text_to_search = ""; //Series;
	search_link_pages_busqueda = search_link_pages; // series
                                   
	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_series = "<div class='message'></div>No hay series disponibles para esta categor&iacute;a.";
	no_matches_available_seasons = "<div class='message'></div>No hay temporadas disponibles para esta categor&iacute;a.";
	no_matches_available_chapters = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de series, un momento por favor";
	message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de series para ";
	log_loading_seasons = "Cargando la pantalla de temporadas para ";
	log_loading_chapters = "Cargando la pantalla de cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

//Configura busquedas y mensajes para buscar pelculas

function seriesyonkis_configure_peliculas() {
	base_url = "http://www.peliculasyonkis.com/";
	estructura = "peliculas"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 50; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.peliculasyonkis.com/"; // peliculas
	search_categories =/<li class=\"page_item\"><a href=\"http:\/\/www.peliculasyonkis.com\/(genero\/[^\"]*)\" title=\"[^\"]*\">([^<]*)<\/a><\/li>/g; // peliculas
	search_link_pages = /<a href='http:\/\/www.peliculasyonkis.com\/genero(\/[^']*)'>([^<]*)<\/a>/g; // peliculas
	search_series =  /<a href=\"http:\/\/www.peliculasyonkis.com\/(pelicula\/[^\"]*)\" title=\"[^\"]*\"><img width=\"77\" height=\"110\" src=\"(http:\/\/p.staticyonkis.com\/thumbs\/[^\"]*)\" alt=\"[^\"]*\" align=\"right\" \/><div align=\"left\"><strong>([^<]*)<\/strong><\/div>/g; // peliculas
	search_versions = /<a href=\"http:\/\/www.peliculasyonkis.com\/(go\/d\/[^\"]*)\" title="Descargar archivo" target='_blank'>(DESCARGAR DE megaupload)<\/a>/g; //peliculas
	search_brief = /Sinopsis de la pel[^<]*<br \/><b>([^<]*)<\/b><\/li>/g; //peliculas


	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // peliculas


	url_novelties = "http://www.peliculasyonkis.com/ultimas-peliculas/ultimas/"; // peliculas
	search_novelties = /<a href=\"http:\/\/www.peliculasyonkis.com(\/pelicula\/[^\"]*)\" title=\"[^\"]*\"><img width='100' height='144' src='(http:\/\/p.staticyonkis.com\/thumbs\/[^']*)' alt='[^']*'\/><br \/>([^<]*)<\/a>/g; // peliculas
	url_buscar = "http://www.peliculasyonkis.com/buscarPelicula.php?s="; //Peliculas
	text_to_search = ""; //Peliculas;
	search_link_pages_busqueda = search_link_pages;





	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_chapters = "<div class='message'></div>No hay pel&iacute;culas disponibles para esta categor&iacute;a.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para esta pel&iacute;cula.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de pel&iacute;culas, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de pel&iacute;culas para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

/************************/
/*	Main		*/
/************************/

var seriesyonkis_main_list;

//Initialize the behaviour of the main page

function seriesyonkis_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Razon: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			log(log_page_not_found);
			break;
	}
}

function seriesyonkis_search_error_callback() {
	log(log_error_analizing_data + current_url);
	v_loading=false;
}

function seriesyonkis_init_main(){
	//if(DEBUG) log ("Inicializando main");
	list_no_matches_available = no_matches_available_main;
	//Visitamos primero pa pagina de acceso por si hay alguna cookie o alguna medida de seguridad
	//HED.helpers.url({url: current_url = "http://www.cinetube.es/", matchlink: "http://*peliculas/*", cbok: function(data) {}});
	//La expresin regular de la siguiente linea es lo que selecciona las categorias. 
	//Se puede cambiar para que salgan clasificadas de otra forma, pero el orden alfabetico es 
	//la nica forma que he encontrado para que las listas salgan enteras en una pgina.
	//Si no sale todo en una pgina habra que complicar el resto de busquedas para que tnegan en cuenta las busquedas paginadas
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	HED.helpers.url({url: current_url = url_categories, match: match_current = search_categories, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if(DEBUG) log("Loaded main page");
		//if (this_loading_ref !== v_loading_ref) return;
		seriesyonkis_main_list =new Array();
		seriesyonkis_main_list.push({title: "Novedades", url: ""});
		seriesyonkis_main_list.push({title: "Buscar", url: ""});
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) seriesyonkis_main_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		v_visible=14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriesyonkis_search_error_callback, cbmx: seriesyonkis_multiplexed_callback});
}

//Renderiza el men de categoras

function seriesyonkis_render_main() {
	list_render(seriesyonkis_main_list,"", "seriesyonkis_");
}

//What to do when OK is pressed under the main menu

function seriesyonkis_action_main() {
	//Novedades
	if ((v_screen_sel==0) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_novelties;
		cathegory_title_backup = "Novedades";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "series";
	}
	//buscar
	else if ((v_screen_sel==1) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_buscar;
		cathegory_title_backup = "Buscar";
		//if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "search";
	}
	else if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel-2})) !== false) {
		if ((cathegory_title_backup != v_screen_sel_data.title) || (!pages_left)) page_number = 0;
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) cathegory_url_backup = base_url + v_screen_sel_data.url; else cathegory_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) cathegory_title_backup = v_screen_sel_data.title; else cathegory_title_backup = "(descarga progresiva en curso)";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		if(estructura=="peliculas") {
			serie_return_backup="main";
			v_screen = "series";
		}
		if(estructura=="series") {
			chapter_return_backup="main";
			v_screen = "chapters";
		}
	}
}

/************************/
/*	Search		*/
/************************/

//Initialize the behaviour of the search page

function seriesyonkis_init_search(){
	//if(DEBUG) log ("Inicializando search");
	render_screen();
	render_focus();
	//if (this_loading_ref !== v_loading_ref) return;
	v_loading = false;
}

//Renderiza el men de bsqueda

function seriesyonkis_render_search() {
	var divheight = 36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;
	maximum=5;

	//if (DEBUG) log("Renderizando la pantalla de bsqueda");
	//Comprueba los lmites
	if (v_screen_sel < 0) v_screen_sel = maximum - 1;
	if (v_screen_sel >= maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;

	//Margen con el ttulo
	dumphtml += "<div class='seriesyonkis_noarrow_search'></div>";

	//div para el input_text
	dumphtml += "<div id='write_here'/>";

	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;

	//Define el cuadro de texto
	var my_input = HED.widgets.input_text({
        	parent: $('#write_here'),
        	type: 'text',
        	initText: text_to_search,
        	defaultEnabled: true,
        	oStyle: {'width': '600px', 'height': '30px', 'margin': '0 auto'},
	        fCallback: {
		        select: function(oEvent, thevalue) {
				if (oEvent.keyCode==HED.KC_RETURN) {
					v_screen = "main"
					init_screen();
				}
				else {
					page_number = 0;
					cathegory_url_backup = url_buscar + thevalue;
					cathegory_title_backup = "Buscar: "+ thevalue;
					if (DEBUG) log(log_loading_series + cathegory_url_backup);
					serie_return_backup="main";
					v_screen = "series";
					cathegory_ofs_backup = v_screen_ofs;
					cathegory_sel_backup = v_screen_sel;
					init_screen();
		        	}
			}        
	        },        
		kc : {
			undo: [],
			enable : [],
			disable: [],
			select: [HED.KC_ENTER, HED.KC_RETURN]
		}
	});
	$('#write_here a:first').focus();
}

//What to do when OK is pressed under the search menu

function seriesyonkis_action_search() {};

/************************/
/*	Series		*/
/************************/



function seriesyonkis_init_series(){
	//if (DEBUG) log(cathegory_url_backup);
	//HED.helpers.url({url: current_url = "about:blank", cbok: function (data){}});
	if ((cathegory_title_backup == "Novedades")){   // || (cathegory_title_backup == "Buscar")) {
		if (DEBUG) log("Cargando Novedades");
		if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading_series_list;
		//Configure template
		//Funcin que genera las pginas consecutivas
		cover_matrix_generate_page_url = function (n) {
 			return cathegory_url_backup;
		};
		//Funcin que comprueba si la pagina actual es la ltima 
		cover_matrix_check_for_last_page = function(n, url, title) { 	
			return false;
		};
		if (estructura=="peliculas") cover_matrix_matchnames = ["url", "image", "title"];
		else cover_matrix_matchnames = ["image", "url", "title"];
		template_key_handler = cover_matrix_key_handler;
		focus_div = cover_matrix_focus_div;
		blur_div = cover_matrix_blur_div;
		cover_matrix_title = cathegory_title_backup;
		cover_matrix_search = search_novelties;
		//cover_matrix_search_link_pages = / /g;
		cover_matrix_links_per_page = links_per_page;
		cover_matrix_no_matches_available = no_matches_available_series;
		cover_matrix_log_error_analizing_data = log_error_analizing_data;
		cover_matrix_log_error_getting_pages_pre = log_error_getting_pages_pre;
		cover_matrix_log_error_getting_pages_post = log_error_getting_pages_post;
		v_visible=14;
		cover_matrix_page_number=0;
		cover_matrix_load_page();
	}
	//Recorre las pginas de pelculas para capturar los enlaces
	else {
		//Configure template
		//Funcin que genera las pginas consecutivas
		cover_matrix_generate_page_url = function (n) {
			if (cathegory_title_backup.search("Buscar:")!=-1) return cathegory_url_backup;
			else return cathegory_url_backup.substring(0, cathegory_url_backup.length - 2) + (n-1) + "/";
		};
		//Funcin que comprueba si la pagina actual es la ltima 
		cover_matrix_check_for_last_page = function(n, url, title) { 
			if (title > n) return true;
			else return false;
		};
		cover_matrix_matchnames = ["url", "image", "title"];
		template_key_handler = cover_matrix_key_handler;
		focus_div = cover_matrix_focus_div;
		blur_div = cover_matrix_blur_div;
		cover_matrix_title = cathegory_title_backup;
		cover_matrix_search = search_series;
		cover_matrix_search_link_pages = search_link_pages;
		cover_matrix_links_per_page = links_per_page;
		cover_matrix_no_matches_available = no_matches_available_series;
		cover_matrix_log_error_analizing_data = log_error_analizing_data;
		cover_matrix_log_error_getting_pages_pre = log_error_getting_pages_pre;
		cover_matrix_log_error_getting_pages_post = log_error_getting_pages_post;
		v_visible=14;
		cover_matrix_page_number=0;
		cover_matrix_load_page();
	}

}

//Renderiza el men de series (Con cartulas)

function seriesyonkis_render_series() {
	cover_matrix_render("seriesyonkis_");
}

//What to do when OK is pressed under the series menu

function seriesyonkis_action_series() {
	if ((estructura=="series")&&(cathegory_title_backup.search("Buscar: ")==-1)) var match_names_series = ["image", "url", "title"];
	else var match_names_series = ["url", "image", "title"];
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel, matchnames: match_names_series})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) serie_url_backup = base_url + v_screen_sel_data.url; else serie_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) serie_title_backup = v_screen_sel_data.title; else serie_title_backup = cathegory_title_backup;
		//if(DEBUG) log("url= " + serie_url_backup);
		//if(DEBUG) log("image= " + v_screen_sel_data.image);
		if(serie_url_backup.search("serie-documental")!=-1) { 
			if (DEBUG) log(log_loading_chapters + serie_url_backup);
			chapter_return_backup="series";
			v_screen = "chapters";
		}
		else {
			if (cathegory_title_backup == "Novedades"){
				if (serie_url_backup.search("capitulo")!=-1) {
					chapter_url_backup = serie_url_backup;
					chapter_title_backup = serie_title_backup;
					if (DEBUG) log(log_loading_versions + serie_url_backup);
					v_screen = "versions";
					version_return_backup="series";
				}
				else {
					season_url_backup = serie_url_backup;
					season_title_backup = serie_title_backup;
					if (estructura=="series"){
						if (DEBUG) log(log_loading_chapters + serie_url_backup);
						v_screen = "versions";
						version_return_backup="series";
					}
					if (estructura=="peliculas"){
						if (DEBUG) log(log_loading_versions + serie_url_backup);
						if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
						v_screen = "versions";
						version_return_backup="series";
					}
					if (estructura=="documentales"){
						if (DEBUG) log(log_loading_versions + serie_url_backup);
						page_number=0;
						v_screen = "versions";
						version_return_backup="series";
					}
				}
			}
			else {
				if((estructura=="peliculas") || (estructura=="documentales")) if (DEBUG) log(log_loading_versions + serie_url_backup);
				if(estructura=="series") if (DEBUG) log(log_loading_chapters + serie_url_backup);
				if((estructura=="peliculas") || (estructura=="documentales")) {
					v_screen = "versions";
					version_return_backup="series";
					if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
				}
				if(estructura=="series") {
					v_screen = "chapters";
					chapter_return_backup="series";
						if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
				}
			}
		}
	}
	imagen=v_screen_sel_data.image;
	titulo=v_screen_sel_data.title;
}

/************************/
/*	Seasons		*/
/************************/

//Initialize the behaviour of the seasons page

function seriesyonkis_init_seasons(){}

//Renderiza el men de temporadas

function seriesyonkis_render_seasons() {}

//What to do when OK is pressed under the seasons menu

function seriesyonkis_action_seasons() {}


/************************/
/*	Chapters	*/
/************************/

//Initialize the behaviour of the chapters page


var seriesyonkis_chapters_list;

var seriesyonkis_chapters_datos_imagen;
var seriesyonkis_chapters_titulo;

function seriesyonkis_init_chapters(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	if ((estructura == "series") && (cathegory_title_backup.search("Buscar: ")==-1)) var url_busqueda = cathegory_url_backup;
	else var url_busqueda = serie_url_backup;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = search_chapters, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if (this_loading_ref !== v_loading_ref) return;
		seriesyonkis_chapters_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) seriesyonkis_chapters_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		seriesyonkis_chapters_datos_imagen = HED.helpers.url({url: current_url, matchnames: ["image"], match: search_image, get: 0, cbmx: seriesyonkis_multiplexed_callback});
		if (cathegory_title_backup.search("Buscar: ")!=-1) seriesyonkis_chapters_titulo = serie_title_backup;
		else seriesyonkis_chapters_titulo = cathegory_title_backup;
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriesyonkis_search_error_callback, cbmx: seriesyonkis_multiplexed_callback});
}

//Renderiza el men de captulos

function seriesyonkis_render_chapters() {

	list_render(seriesyonkis_chapters_list,"<div class='seriesyonkis_imagetitle' > " + seriesyonkis_chapters_titulo + "</div><div class='seriesyonkis_coverimage'><img src='"+seriesyonkis_chapters_datos_imagen.image+"' width=\"134\" height=\"193\" border=\"0\" /></div>", "seriesyonkis_");

}

//What to do when OK is pressed under the chapters menu

function seriesyonkis_action_chapters() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) chapter_url_backup = base_url + v_screen_sel_data.url; else chapter_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) chapter_title_backup = v_screen_sel_data.title; else chapter_title_backup = season_title_backup;
		if (DEBUG) log(log_loading_versions + chapter_url_backup);
		v_screen = "versions";
		version_return_backup="chapters";
	}
}

/************************/
/*	Versions	*/
/************************/

//Initialize the behaviour of the versions page

function seriesyonkis_init_versions(){
	template_key_handler = others_key_handler;
	focus_div = others_focus_div;
	blur_div = others_blur_div;
	//HED.helpers.url({url: current_url = "about:blank", cbok: function (data){}});
	//La expresin regular de la siguiente linea es la que busca enlaces a las pginas de descarga
	if (estructura == "series") var busqueda = chapter_url_backup;
	if (estructura == "peliculas") var busqueda = serie_url_backup;
	var busqueda_versiones = search_versions;
	if (estructura == "documentales") {
		var busqueda = serie_url_backup;
		if (serie_url_backup.search("serie-documental")!=-1) {
			var busqueda = chapter_url_backup;
			busqueda_versiones=search_versions_series;
		}	
	}
	HED.helpers.url({url: current_url = busqueda, match: match_current = busqueda_versiones, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
		//if (this_loading_ref !== v_loading_ref) return;
		v_screen_ofs = version_ofs_backup; 	/// restore backup
		v_screen_sel = version_sel_backup; 	/// restore backup
		megaupload_return_backup = "versions";
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: seriesyonkis_search_error_callback, cbmx: seriesyonkis_multiplexed_callback});
}

function dehtml(instr) {
	if ((typeof instr) != "string") return "";
	var openpos;
	var closepos;
	var alt = false;
	var src = false;
	if ((openpos = instr.indexOf("alt=\"")) >= 0) if ((closepos = instr.indexOf("\"", openpos + 5)) >= 0) alt = instr.substring(openpos + 5, closepos);
	if ((openpos = instr.indexOf("src=\"")) >= 0) if ((closepos = instr.indexOf("\"", openpos + 5)) >= 0) src = instr.substring(openpos + 5, closepos);
	while ((openpos = instr.indexOf("<")) >= 0) {
		if ((closepos = instr.indexOf(">", openpos)) >= 0) instr = instr.substr(0, openpos) + " " + instr.substr(closepos + 1);
		else instr = instr.substr(0, openpos);
	}
	return {'text': instr, 'alt': alt, 'src': src};
}

//Renderiza el men de versiones

function seriesyonkis_render_versions() {
	var divheight=36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 6;

	//Reduce el tamao del men para dejar sitio a la sinopsis en el caso de los documentales o las pelculas
	if( ((estructura == "peliculas")) || ((estructura == "documentales") && (serie_url_backup.search("serie-documental")==-1)) ) v_visible = 7;

	//Calcula el numero de elementos
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Comprueba los lmites
	if (v_screen_sel < 0) v_screen_sel = maximum - 1;
	if (v_screen_sel >= maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
	
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout( function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = no_matches_available_versions;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		var cover;
		var afterstring;
		var aftermatch;
		var aftermatch_noenters;
		var aftermatches;
		var afterdehtmls;

		aftermatch = new RegExp("<td>(.*?)</td>", "igm");
		aftermatch_noenters = new RegExp("\\n", "igm");
		if(DEBUG) log("Obteniendo características de los streams.");
		//Red Arrow
		if (v_screen_ofs > 0) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='seriesyonkis_arrow_list seriesyonkis_redarrow_list'>&#9650;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='seriesyonkis_noarrow_list'></div>";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i});
			//description = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.title ? v_screen_tmp_data.title : "");
			description = (v_screen_tmp_data === false) ? "" : ("#" + (v_screen_ofs + i + 1));
			try {
				afterstring = HED.helpers.url({get: "after" + (v_screen_ofs + i)});
				afterstring = afterstring.replace(aftermatch_noenters, "");
				try {
					aftermatches = afterstring.match(aftermatch);
					try {
						for (var ii = 0; ii < aftermatches.length; ++ii) {
							afterdehtmls = dehtml(aftermatches[ii]);
							switch (ii) {
								case 0:
									//if (afterdehtmls.alt) description += " " + afterdehtmls.alt;
									//log("#0: " + afterdehtmls.text);
									break;
								case 1:
									if (afterdehtmls.text.length > 0) description += " / " + afterdehtmls.text;
									//log("#1: " + afterdehtmls.text);
									break;
								case 2:
									if (afterdehtmls.text.length > 0) description += " / subs: " + afterdehtmls.text;
									//log("#2: " + afterdehtmls.text);
									break;
								case 3:
									if (afterdehtmls.src) description += " / <img src=\"" + afterdehtmls.src + "\" />";
									//log("#3: " + afterdehtmls.text);
									break;
								case 4:
									if (afterdehtmls.text.length > 0) description += " / " + afterdehtmls.text;
									//log("#4: " + afterdehtmls.text);
									break;
								case 5:
									if (afterdehtmls.text.length > 0) description += " / up: " + afterdehtmls.text;
									//log("#5: " + afterdehtmls.text);
									break;
							}
						}
					} catch (e) {
						//log("err3");
					}
				} catch (e) {
					//log("err2");
				}
			} catch (e) {
				//log("err1");
			}
			if (description.length > 120) description = description.substr(0, 120) + "...";


			//description += "<span style='font-size:0.6em;'> " + v_screen_tmp_data.description + "</span>";
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			dumphtml += "<div style='height:" + divheight + "px;' class='seriesyonkis_elementdiv_list'><a href='#' id='element" + i + "' class='seriesyonkis_element_list'>" + description + "</a></div>";
		}
		//Blue Arrow
		if (v_screen_ofs < maximum - v_visible) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='seriesyonkis_arrow_list seriesyonkis_bluearrow_list'>&#9660;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='seriesyonkis_noarrow_list'></div>";
		//Incluye el resumen y la cartula si la estructura es la de las peliculas o documentales
		if( ((estructura == "peliculas")) || ((estructura == "documentales") && (serie_url_backup.search("serie-documental")==-1)) ) {
			//if(DEBUG) log("Getting sinopsis");
			var datos = HED.helpers.url({url: current_url, matchnames: ["brief"], match: search_brief, get: 0, cbmx: seriesyonkis_multiplexed_callback});
			dumphtml = "<div class='seriesyonkis_ficha'><div class='seriesyonkis_coverimage'><img src='"+imagen+"' width=\"134\" height=\"193\" border=\"0\" /></div><div class='seriesyonkis_imagetitle'> " + titulo + "</div><br><div class='seriesyonkis_brief'>" + datos.brief + "</div></div>" + dumphtml;
		}
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}


function get_megaupload_url(idurl, callback) {
	if (idurl.indexOf("?id=") >= 0) {
		idurl = idurl.substr(idurl.indexOf("?id=") + 4);
	} else if (idurl.indexOf("&id=") >= 0) {
		idurl = idurl.substr(idurl.indexOf("&id=") + 4);
	} else {
		idurl = false;
	}
	if (idurl !== false) {
		if (idurl.indexOf("&") >= 0) idurl = idurl.substr(0, idurl.indexOf("&"));
		HED.helpers.fork({url: 'plugins/seriesyonkis/seriesyonkis.deko.html?id=' + idurl, cbok: callback});
	}
}

//What to do when OK is pressed under the versions menu

function seriesyonkis_action_versions() {
	if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
	if ((v_screen_sel_data = HED.helpers.url({get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) {
			version_url_backup = v_screen_sel_data.url;
			v_screen = "megaupload";
			if (domobj = document.getElementById("fields")) domobj.innerHTML = message_getting_information_versions; 
			if (domobj = document.getElementById("title")) domobj.innerHTML = message_getting_information_versions_title;
			if (DEBUG) log(log_loading_descriptor + base_url + version_url_backup);
			var url_descriptor = base_url + version_url_backup;
			HED.utils.http_post(url_descriptor, "", "", function(oData) {
					url_descriptor = oData.headers.location[0];
					log("Carga ok, obteniendo el stream " + url_descriptor);
					get_megaupload_url(
						url_descriptor,
						function(megaupload_url) {
							if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
							if (v_screen != "megaupload") return;
							if (DEBUG) log("Reproducir " + megaupload_url);
							play_handler(megaupload_url);
						}
					);
				}, function(oData) {if (DEBUG) log(log_error_loading_descriptor)
			});
		}
	}
}

function seriesyonkis_render_focus() {
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});	
	if(v_screen=="main") maximum+=2;
	if((v_screen == "series") && pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}
	if (v_screen=="search") { 
		//if (DEBUG) log("pagina de busqueda, renderizando foco");
		if (domobj = document.getElementById("write_here")) {
			//if (DEBUG) log("div encontrado");
			domobj.focus();
		}
		else {
			//if (DEBUG) log("no he encontrado el div");
		}
	}
	else {
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel - v_screen_ofs);
		}
	}

	var titulo = "";

	switch (v_screen) {
		case "main":
			if (maximum > 0) titulo = media_title_backup + " / " + "Categor&iacute;as " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = media_title_backup + " / " + "Categor&iacute;as";
			break;
		case "search":
			titulo = media_title_backup + " / " +"Buscar " + text_to_search;
			break;
		case "series":
			if(cover_matrix_pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + "  " + (v_screen_sel + 1) + " / ---";
			if(!cover_matrix_pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + "  " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = cathegory_title_backup;
			break;
		case "seasons":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / Temporadas disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "chapters":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / " + season_title_backup + " / Cap&iacute;tulos disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "versions":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / " + season_title_backup + " / " + chapter_title_backup + " / Versiones disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
	}
	if (titulo.length>70) titulo = "..." + titulo.slice(titulo.length-70);
	if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
}