if(DEBUG) log("Loading template: list");

var list_no_matches_available = "<div class='message'></div>No se han encontrado contenidos.";
var list_maximum = 0;


function list_render(list, heading, style_prefix) {


	var dumphtml = "";
	//heading can be used to insert any HTML code as a heading for the list rendering
	if (heading!=undefined) dumphtml += heading;
	//style_prefix can be used to redefine the style of the elemnts used in rendering the list. This prefix will be inserted in all CSS class elements used, so the style can be redefined in other CSS files. Please see the list.css file to view all the classes used in this template
	if (style_prefix == undefined) style_prefix = "";
	//v_visible = 14;

	//Calculate the number of elements available in the list
	list_maximum = list.length;
	//if (DEBUG) log("La lista contiene " + list_maximum + " elementos");

	//Check cursor indexes are not outside the scope of the list
	if (v_screen_sel < 0) v_screen_sel = list_maximum - 1;
	if (v_screen_sel >= list_maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//If no elemnts are available in the list, show an error
	if (list_maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = list_no_matches_available;}, 250);
	} else { //And if there are any, render the menu
		var description;
		//Red arrow
		if (v_screen_ofs > 0) dumphtml += "<div class='" + style_prefix + "arrow_list " + style_prefix + "redarrow_list'>&#9650;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_list'></div>";
		//Main loop for showing all available elements
		for (var i = 0; i < v_visible; i++) {
			if (v_screen_ofs + i < list_maximum) {
				//Read the data from the match number i
				var v_screen_tmp = list[i+ v_screen_ofs];
				//if (DEBUG) log("Incluyendo " + v_screen_tmp_data.title);
				description = (v_screen_tmp === false) ? "" : (v_screen_tmp.title ? v_screen_tmp.title : "");
				//Add element number i to the menu
				dumphtml += "<div class='" + style_prefix + "elementdiv_list'><a href='#' id='element" + i + "' class='" + style_prefix + "element_list'>" + description +"</a></div>";
			}
		}
		//Blue arrow
		if (v_screen_ofs < list_maximum - v_visible) dumphtml += "<div class='" + style_prefix + "arrow_list " + style_prefix + "bluearrow_list'>&#9660;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_list'></div>";
	}
	//Rendering is ready, show the menu
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}


/************************/
/*	Focus Handling	*/
/************************/

function list_focus_div(divid) {
	if (domobj = document.getElementById("element" + divid)) domobj.focus();
}

function list_blur_div(divid) {
}


/************************/
/*	Input Handling	*/
/************************/

function list_key_handler(e) {
	if(!v_loading) switch (e.keyCode) {
		case 38: ///< UP
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			--v_screen_sel;
			if(v_screen_sel<v_screen_ofs) render_screen();
			render_focus();
			break;
		case 40: ///< DOWN
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			++v_screen_sel;
			if(v_screen_sel>=v_screen_ofs+v_visible) render_screen();
			render_focus();
			break;
		case 33: case 114: ///< PREVPG and RED
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				v_screen_sel -= v_visible;
				//v_screen_sel--;
				v_screen_ofs -= v_visible;
				render_screen();
				render_focus();
			}
			break;
		case 34: case 117: ///< NEXTPG and BLUE
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			v_screen_sel += v_visible;
			//v_screen_sel+=2;
			v_screen_ofs += v_visible;
			render_screen();
			render_focus();
			break;
		case 116: case 188: ///< YELLOW
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				v_screen_sel -= v_visible * 4;
				//v_screen_sel--;
				v_screen_ofs -= v_visible * 4;
				render_screen();
				render_focus();
			}
			break;
		case 115: case 190: ///< GREEN
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			if (links_per_page<v_visible * 4) v_screen_sel += v_visible;
			else v_screen_sel += v_visible * 4;
			//v_screen_sel+=2;
			if (links_per_page<v_visible * 4) v_screen_ofs += v_visible;
			else v_screen_ofs += v_visible * 4;
			render_screen();
			render_focus();
			break;
		default:
			//if (DEBUG) log(log_unhandled_key + e.keyCode);
			break;
	}
	//e.stopPropagation();
}

