﻿// Pelis a la carta

var DEBUG = false;

//This variable contains the link to the key handler to be used by each presentation template. Must be configured properly by the time the menu is initializated

var template_key_handler = function generic_key_handler(e) {};

// these two variables contain the lint to the functions to modify the style of a div when selected and unselected

var focus_div = function _focus_div(divid) {};
var blur_div = function _blur_div(divid) {};

//END of Templates configuration

var estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
var links_per_page = 21; // Numero de links que hay en cada página de Cinetube

//Variables for "series" pagination working

var all_data;
var page_number;
var num_pages;
var pages_left;

//Variables for menu navigation backups

var channel_ofs_backup = 0; /// offset backup
var channel_sel_backup = 0; /// selection backup
var channel_title_backup = "";
var channel_return_backup = undefined;

var media_ofs_backup = 0; /// offset backup
var media_sel_backup = 0; /// selection backup
var media_title_backup = "";
var media_return_backup = undefined;

var cathegory_url_backup = undefined; /// url backup
var cathegory_ofs_backup = 0; /// offset backup
var cathegory_sel_backup = 0; /// selection backup
var cathegory_title_backup = "";
var cathegory_return_backup = undefined;

var serie_url_backup = undefined; /// url backup
var serie_ofs_backup = 0; /// offset backup
var serie_sel_backup = 0; /// selection backup
var serie_title_backup = "";
var serie_return_backup = undefined;

var season_url_backup = undefined; /// url backup
var season_ofs_backup = 0; /// offset backup
var season_sel_backup = 0; /// selection backup
var season_title_backup = "";
var season_return_backup = undefined;

var chapter_url_backup = undefined; /// url backup
var chapter_ofs_backup = 0; /// offset backup
var chapter_sel_backup = 0; /// selection backup
var chapter_title_backup = "";
var chapter_return_backup = undefined;

var version_url_backup = undefined; /// url backup
var version_ofs_backup = 0; /// offset backup
var version_sel_backup = 0; /// selection backup
var version_id_backup = undefined;
var version_return_backup = undefined;

var megaupload_url_backup = undefined;
var megaupload_stream_url_backup = undefined;
var megaupload_return_backup = undefined;

var search_return_backup = undefined;

// Log variables

var log_count = 0;
var log_next_clear = false;

var base_url = "http://www.cinetube.es/";

// Búsquedas

var url_categories = "http://www.cinetube.es/series/"; // series
var search_categories =/<li><a href=\"(series[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // series
var search_link_pages = /<li class=\"pagina\"><a href=\"(\/series[^\"]*)\">([^<]*)<\/a><\/li>/g; // series
var search_series = /<li>[^<]*<a href=\"\/(series\/[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"peli\" \/>[^_]*_lg\">[^_]*_ficha\">([^<]*)<\/p>/g; // series 
var search_seasons = /<li><h2><a href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/h2><span><[^>]*>([^\|]*)\|/g; // series
var search_brief = /<h3 class=\"tit_cent\">Ficha de la serie<\/h3>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^<]*<p>([^<]*)<\/p>/g; //series
var search_chapters = /<div class=\"title\"> <a class=\"bold\" href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/div>/g; //series
var search_versions = /<div class=\"tit_opts\"><a href=\"\/(series\/descargar[^\"]*)\" target=\"_BLANK\">[^<]*<p>([^<]*)<span class=\"bold\"><\/span><\/p>[^<]*<p><span>([^<]*)<\/span><\/p>[^<]*<p class=\"v_ico\"><img src=\"http:\/\/caratulas.cinetube.es\/img\/cont\/megaupload.png\" alt=\"Megaupload\"/g; //series
var search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // series
var url_novelties = "http://www.cinetube.es/series/"; // series
var search_novelties = /<li>[^<]*<a href="\/(series[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\"[^_]*_lg\">[^_]*_[^_]*_ficha\"[^>]*>[^<]*<\/a><\/p>[^<]*<p class=\"tem_fich\">([^<]*)<\/p>/g; //series
var url_buscar = "http://www.cinetube.es/buscar/series/?palabra="; //Series
var text_to_search = ""; //Series;
var search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/series\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series
                                   
// HTML Mensajes

var no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
var no_matches_available_series = "<div class='message'></div>No hay series disponibles para esta categor&iacute;a.";
var no_matches_available_seasons = "<div class='message'></div>No hay temporadas disponibles para esta categor&iacute;a.";
var no_matches_available_chapters = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
var no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
var message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
var message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
var message_megaupload_load_post = "</div>";
var message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
var message_megaupload_found_stream_ok_post = "</div>";
var message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
var message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
var message_megaupload_done_title = "Reproducci&oacute;n";
var message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
var message_megaupload_done_post = "</div>";
var message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
var message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
var message_megaupload_wait_post = "</div>";
var message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
var message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
var message_getting_information_versions_title = message_megaupload_done_title;
var message_loading_series_list = "<div class='message'></div>Cargando lista de series, un momento por favor";
var message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
var message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

// Log messages

var log_not_supported_fname = "alguna funci&oacute;n"
var log_not_supported_pre = "<span style='color:red'>No se soporta ";
var log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
var log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
var log_loading_series = "Cargando la pantalla de series para ";
var log_loading_seasons = "Cargando la pantalla de temporadas para ";
var log_loading_chapters = "Cargando la pantalla de cap&iacute;tulos para ";
var log_loading_versions = "Cargando la pantalla de versiones para ";
var log_loading_descriptor = "Cargando el descriptor ";
var log_error_loading_descriptor = "Error analizando descriptor";
var log_unhandled_key = "unhanled key: ";
var log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
var log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
var log_error_getting_pages_post = " p&aacute;ginas";
var log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
var log_error_loading_pages_post = " solo se mostraran algunos de los medios";
var log_error_analizing_data = "Error analizando datos de ";
var log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";

//Other variables

var match_current = "";
var matchlink_current = "";
var current_url = "";
var titulo = "";
var imagen = "";

var anim_puntos=[". ."," ..",".. "];

var domobj; /// temporal domobj variable

var v_download_id = undefined; /// download id: undefined if not yet loaded or uninitialized

var v_loading = true; /// we are loading a screen, do not attend 13
var v_loading_ref = 0; /// loading ref, avoid merges
var v_cancel_playback = false;
var v_visible = 12; /// number of visible elements
var v_screen = "channels"; /// current screen, can be "media", "main", "series", "seasons", "chapters" and "versions"
var v_screen_ofs = 0; /// current screen offset (first visible element position)
var v_screen_ofs_last = 0;
var v_screen_sel = 0; /// current selected element
var v_screen_sel_last = 0;
var v_screen_sel_data = false; /// current selected element
var v_screen_tmp_data = false; /// current selected element
var v_screen_ref = 0; /// current screen load count (for discard old screens)

// Functions for configuring searches and messages
// Redefined by each plugin
var configure_peliculas = function configure_peliculas() {};
var configure_series = function	configure_series() {};
var configure_documentales = function configure_documentales(){};
var configure_peliculas_anime = function configure_peliculas_anime(){};
var configure_series_anime = function configure_series_anime(){};

// Functions for configuring render and initialization
// Redefined by each plugin
var render_focus_plugin = function render_focus_plugin_void(){};
var init_main= function init_main(){};
var render_main = function render_main() {};
var action_main = function action_main() {};
var init_search = function init_search(){};
var render_search = function render_search() {};
var action_search = function action_search() {};
var cargar_pagina = function cargar_pagina(){};
var init_series = function init_series(){};
var render_series = function render_series() {};
var action_series = function action_series() {};
var init_seasons = function init_seasons(){};
var render_seasons = function render_seasons() {};
var action_seasons = function action_seasons() {};
var init_chapters = function init_chapters(){};
var render_chapters = function render_chapters() {};
var action_chapters = function action_chapters() {};
var init_versions = function init_versions(){};
var render_versions = function render_versions() {};
var action_versions = function action_versions() {};

stream = false;

/************************/
/*	Channels	*/
/************************/

var channel_style_prefix;
var channels_list = new Array();

//Initialize the behaviour of the channels page

function init_channels(){
	//if(DEBUG) log ("Inicializando channels");
	v_visible=5;
	template_key_handler = cover_list_key_handler;
	focus_div = cover_list_focus_div;
	blur_div = cover_list_blur_div;
	cover_list_no_matches_available = no_matches_available_main;
	channels_list = new Array();
	for (var i=0; i<plugin_number; i++) channels_list.push({title: plugin_name_list[i], url: "", cover: plugin_icon_list[i]});
	render_screen();
	render_focus();
	//if (this_loading_ref !== v_loading_ref) return;
	v_loading = false;
}


//Renderiza el menú de canales de medios

function render_channels() {
	cover_list_render(channels_list,"", "");
}

//What to do when OK is pressed under the channels menu

function action_channels() {

	if (domobj = document.getElementById("fields")) domobj.className = plugin_var_list[v_screen_sel]+"_fields";
	if (domobj = document.getElementById("series")) domobj.className = plugin_var_list[v_screen_sel]+"_series";
	if (domobj = document.getElementById("title_bar")) domobj.className = plugin_var_list[v_screen_sel]+"_title_bar";
	if (domobj = document.getElementById("title_image")) domobj.className = plugin_var_list[v_screen_sel]+"_title_image";
	domobj.innerHTML="<img src='" + plugin_logo_list[v_screen_sel] + "' />";
	if (domobj = document.getElementById("title")) domobj.className = plugin_var_list[v_screen_sel]+"_title";

	channel_style_prefix = plugin_var_list[v_screen_sel]+"_";

	plugin=eval(plugin_var_list[v_screen_sel]);
	//Configure Plugin
	init_main= plugin.init[0];
	init_search = plugin.init[1];
	init_series = plugin.init[2];
	init_seasons = plugin.init[3];
	init_chapters = plugin.init[4];
	init_versions = plugin.init[5];
	cargar_pagina = plugin.load[0];
	render_main = plugin.render[0];
	render_search = plugin.render[1];
	render_series = plugin.render[2];
	render_seasons = plugin.render[3];
	render_chapters = plugin.render[4];
	render_versions =  plugin.render[5];
	action_main = plugin.action[0];
	action_search = plugin.action[1];
	action_series = plugin.action[2];
	action_seasons = plugin.action[3];
	action_chapters = plugin.action[4];
	action_versions =  plugin.action[5];
	channel_title_backup=plugin.title;
	render_focus_plugin = plugin.focus[0];
}

/************************/
/*	Media		*/
/************************/

var media_list = new Array();

//Initialize the behaviour of the media page

function init_media(){
	//if(DEBUG) log ("Inicializando media");
	list_no_matches_available = no_matches_available_main;
	template_key_handler = list_key_handler;
	v_visible=14;
	focus_div = list_focus_div;
	blur_div = list_blur_div;
	media_list = new Array();
	for(var i=0;i<plugin.media.length/2; i++) media_list.push({title: plugin.media[i*2], url: ""});
	render_screen();
	render_focus();
	v_loading = false;
}

//Renderiza el menú de selección del tipo de medios

function render_media() {
	list_render(media_list,"", channel_style_prefix);
}

//What to do when OK is pressed under the media menu

function action_media() {};



/****************************************/
/*	Render Screen Main Switch	*/
/****************************************/

//Selecciona el tipo de menu que se quiere mostrar

function render_screen() {
	switch (v_screen) {
		case "channels":
			render_channels();
			break;
		case "media":
			render_media();
			break;
		case "main":
			render_main();
			break;
		case "search":
			render_search();
			break;
		case "series":
			render_series();
			break;
		case "seasons":
			render_seasons();
			break;
		case "chapters":
			render_chapters();
			break;
		case "versions":
			render_versions();
			break;
	}
}

/************************/
/*	Focus Handling	*/
/************************/

function render_focus() {
	if (v_screen=="channels") {
		var maximum=plugin_number;
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel-v_screen_ofs);
		}
		var titulo = "";
		if (domobj = document.getElementById("element"+v_screen_sel)) titulo = domobj.innerHTML;
		if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
	}
	else if (v_screen=="media") {
		var maximum=plugin.media.length/2;
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel-v_screen_ofs);
		}
		var titulo = "";
		if (domobj = document.getElementById("element"+v_screen_sel)) titulo = domobj.innerHTML;
		if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
	}
	else render_focus_plugin();
}

/************************/
/*	Play Handler	*/
/************************/

function play_handler(url) {
	var cbmx = function(reason, args) {
		var args_string = "";
		if(v_screen!="megaupload") return false;
		if (((typeof args) == "object") && (args !== undefined)) {
			for (var i in args) if (((typeof args[i]) == "string") || ((typeof args[i]) == "number")) args_string += ((args_string.length > 0) ? ", " : "") + args[i]; else args_string += ((args_string.length > 0) ? ", " : "") + "?";
		}
		console.log("series-widget play_handler: " + reason + "(" + args_string + ")");
		switch (reason) {
			case "play-time":
				if (domobj = document.getElementById("starting_playback")) domobj.style.visibility = "hidden";
				break;
			case "megaupload-wait":
				break;
			default:
				break;
		}
		if (v_cancel_playback) {
			//log("Cancelando reproduccion");
			v_cancel_playback = false;
			//v_screen = "versions";
			//init_screen(); 
			return false;
		}
		switch (reason) {
			case "not-supported":
				var func_name = log_not_supported_fname;
				if ((args) && (args[0])) func_name = args[0];
				log( log_not_supported_pre + func_name + log_not_suppported_post);
				break;
			case "download-start-ok":
				if (domobj = document.getElementById("fields")) domobj.innerHTML = message_download_start_ok;
				break;
			case "play-ok":
				if (domobj = document.getElementById("series")) domobj.style.visibility = "hidden";
				if (domobj = document.getElementById("info")) domobj.style.visibility = "hidden";
				if (domobj = document.getElementById("starting_playback")) domobj.style.visibility = "visible";
				break;
			case "play-error":
				log(log_play_error);
			case "play-finish":
			case "play-stop":
				if (domobj = document.getElementById("series")) domobj.style.visibility = "visible";
				if (domobj = document.getElementById("info")) domobj.style.visibility = "visible";
				if (domobj = document.getElementById("starting_playback")) domobj.style.visibility = "hidden";
				HED.event.send('blusens_webapp', {action: "menuhide-250ms"});
				v_screen = megaupload_return_backup;
				init_screen();
				break;
			case "megaupload-load":
				if (args[0]) if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_load_pre + args[0] + message_megaupload_load_post;
				break;
			case "megaupload-loaded":
				break;
			case "megaupload-found-stream":
				if (args[0]) {
					if (((typeof args[0]) == "string") && ((args[0].toLowerCase().indexOf(".", args[0].toLowerCase().lastIndexOf("/")) < 0) || (args[0].toLowerCase().indexOf(".avi") >= 0) || (args[0].toLowerCase().indexOf(".mp4") >= 0) || (args[0].toLowerCase().indexOf(".mkv") >= 0) || (args[0].toLowerCase().indexOf(".mov") >= 0))) {
						if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_found_stream_ok_pre + args[0] + message_megaupload_found_stream_ok_post;

					} else {
						if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_found_stream_error_pre + args[0] + message_megaupload_found_stream_error_post;
						return false;
					}
				}
				break;
			case "megaupload-done":
				if (domobj = document.getElementById("title")) domobj.innerHTML = message_megaupload_done_title;
				if (args[0]) {
					if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_done_pre + args[0] + message_megaupload_done_post;
				}
				break;
			case "megaupload-wait":
				if (args[0] && args[1]) if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_wait_pre + args[0] + message_megaupload_wait_middle + args[1] + message_megaupload_wait_post;
				break;
			case "megaupload-nostreams":
				if (domobj = document.getElementById("fields")) domobj.innerHTML = message_megaupload_nostreams;
				setTimeout(function() {
					v_screen = "versions"; init_screen();
				}, 5000);
				break;
			default:
				break;
		}
	}
	//Esto hay que cambiarlo para independizar este fichero completamente de la variable estructura. El prototipo de la función debe ser play_handler(url, title)
	if ((estructura=="peliculas") || (estructura=="documentales")) return HED.helpers.play({url: url, cbmx: cbmx, title: serie_title_backup, stream: stream});
	if ((estructura=="series") || (estructura=="series")) return HED.helpers.play({url: url, cbmx: cbmx, title: chapter_title_backup, stream: stream});
}

/************************/
/*	Key Handler	*/
/************************/


function key_handler(e) {
	if(!v_loading) switch (e.keyCode) {
		case 27: ///< RETURN (ESCAPE)
			switch (v_screen) {
				case "channels":
					//if(DEBUG) log("Aqui");
					HED.event.send('blusens_webapp', {action: "menushow-250ms"});
					try { HED.helpers.quit(); } catch (e) { }
					break;
				case "media":
					v_screen = media_return_backup;
					if (domobj = document.getElementById("fields")) domobj.className = "fields";
					if (domobj = document.getElementById("series")) domobj.className = "series";
					if (domobj = document.getElementById("title_bar")) domobj.className = "title_bar";
					if (domobj = document.getElementById("title_image")) domobj.className = "title_image";
					domobj.innerHTML="<img src='tvalacarta.logo.jpg' />";
					if (domobj = document.getElementById("title")) domobj.className = "title";
					init_screen();
					break;
				case "main":
					v_screen = main_return_backup;
					init_screen();
					break;
				case "series":
					v_screen = serie_return_backup;
					init_screen();
					break;
				case "seasons":
					v_screen = season_return_backup;
					init_screen();
					break;
				case "chapters":
					v_screen = chapter_return_backup;
					init_screen();
					break;
				case "versions":
					v_screen = version_return_backup;
					init_screen();
					break;
				case "megaupload":
					v_cancel_playback = true;
					v_screen = megaupload_return_backup;
					init_screen();
					break;
			}
			break;
		case 13: case 32: case 41: ///< ENTER o ESPACIO
			switch (v_screen) {
				case "channels":
					action_channels();
					channel_ofs_backup = v_screen_ofs;
					channel_sel_backup = v_screen_sel;
					v_screen = "media";
					media_return_backup="channels";
					init_screen();
					break;
				case "media":
					action_media();
					media_title_backup=plugin.media[v_screen_sel*2];
					media_ofs_backup = v_screen_ofs;
					media_sel_backup = v_screen_sel;
					plugin.media[v_screen_sel*2+1]();
					v_screen = "main";
					main_return_backup="media";
					init_screen();
					break;
				case "main":
					action_main();
					cathegory_ofs_backup = v_screen_ofs;
					cathegory_sel_backup = v_screen_sel;
					init_screen();
					break;
				case "series":
					action_series();
					serie_ofs_backup = v_screen_ofs;
					serie_sel_backup = v_screen_sel;
					init_screen();
					break;
				case "seasons":
					action_seasons();
					season_ofs_backup = v_screen_ofs;
					season_sel_backup = v_screen_sel;
					init_screen();
					break;
				case "chapters":
					action_chapters();
					chapter_ofs_backup = v_screen_ofs;
					chapter_sel_backup = v_screen_sel;
					init_screen();
					break;
				case "versions":
					if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
					action_versions();
					version_ofs_backup = v_screen_ofs;
					version_sel_backup = v_screen_sel;
					break;
			}
			break;
		default:
			//Pass control to the template currently being used
			template_key_handler(e);
			//console.log(log_unhandled_key + e.keyCode);
			//if (DEBUG) log(log_unhandled_key + e.keyCode);
			break;
	}
	//if(v_screen!="search") e.stopPropagation();
}

/********************************/
/*	Main screen init swith	*/
/********************************/

function init_screen(callback) {
	if (domobj = document.getElementById("series")) domobj.style.visibility = "visible";
	++v_loading_ref;
	var this_loading_ref = v_loading_ref + 0;
	v_loading = true;
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	switch (v_screen) {
		case "channels":
			v_screen_ofs = media_ofs_backup; 	/// restore backup
			v_screen_sel = media_sel_backup; 	/// restore backup
			media_ofs_backup = 0;			/// reset offset backup because is a child
			media_sel_backup = 0;			/// reset selection backup because is a child
			media_return_backup = undefined;
			cathegory_ofs_backup = 0;		/// reset offset backup because is a child
			cathegory_sel_backup = 0;		/// reset selection backup because is a child
			cathegory_return_backup = undefined;
			serie_ofs_backup = 0; 			/// reset offset backup because is a child
			serie_sel_backup = 0; 			/// reset selection backup because is a child
			serie_return_backup = undefined;
			season_ofs_backup = 0; 			/// reset offset backup because is a child
			season_return_backup = undefined;
			season_sel_backup = 0; 			/// reset selection backup because is a child
			chapter_return_backup = undefined;
			chapter_ofs_backup = 0; 		/// reset offset backup because is a child
			chapter_sel_backup = 0; 		/// reset selection backup because is a child
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			search_return_backup = undefined;
			megaupload_return_backup = undefined;
			init_channels();
			v_loading = false;
			//if ((typeof callback) == "function") callback();
			break;
		case "media":
			v_screen_ofs = media_ofs_backup; 	/// restore backup
			v_screen_sel = media_sel_backup; 	/// restore backup
			cathegory_ofs_backup = 0;		/// reset offset backup because is a child
			cathegory_sel_backup = 0;		/// reset selection backup because is a child
			cathegory_return_backup = undefined;
			serie_ofs_backup = 0; 			/// reset offset backup because is a child
			serie_sel_backup = 0; 			/// reset selection backup because is a child
			serie_return_backup = undefined;
			season_ofs_backup = 0; 			/// reset offset backup because is a child
			season_return_backup = undefined;
			season_sel_backup = 0; 			/// reset selection backup because is a child
			chapter_return_backup = undefined;
			chapter_ofs_backup = 0; 		/// reset offset backup because is a child
			chapter_sel_backup = 0; 		/// reset selection backup because is a child
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			search_return_backup = undefined;
			//megaupload_return_backup = undefined;
			init_media();
			v_loading = false;
			//if ((typeof callback) == "function") callback();
			break;
		case "search":
			init_search();
			break;
		case "main":
			v_screen_ofs = cathegory_ofs_backup; 	/// restore backup
			v_screen_sel = cathegory_sel_backup; 	/// restore backup
			serie_ofs_backup = 0; 			/// reset offset backup because is a child
			serie_sel_backup = 0; 			/// reset selection backup because is a child
			serie_return_backup = undefined;
			season_ofs_backup = 0; 			/// reset offset backup because is a child
			season_return_backup = undefined;
			season_sel_backup = 0; 			/// reset selection backup because is a child
			chapter_return_backup = undefined;
			chapter_ofs_backup = 0; 		/// reset offset backup because is a child
			chapter_sel_backup = 0; 		/// reset selection backup because is a child
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			search_return_backup = undefined;
			//megaupload_return_backup = undefined;
			init_main();
			break;
		case "series":
			v_screen_ofs = serie_ofs_backup; /// restore backup
			v_screen_sel = serie_sel_backup; /// restore backup
			season_ofs_backup = 0; 			/// reset offset backup because is a child
			season_return_backup = undefined;
			season_sel_backup = 0; 			/// reset selection backup because is a child
			chapter_return_backup = undefined;
			chapter_ofs_backup = 0; 		/// reset offset backup because is a child
			chapter_sel_backup = 0; 		/// reset selection backup because is a child
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			//megaupload_return_backup = undefined;
			init_series();
			break;
		case "seasons":
			v_screen_ofs = season_ofs_backup; 	/// restore backup
			v_screen_sel = season_sel_backup; 	/// restore backup
			chapter_return_backup = undefined;
			chapter_ofs_backup = 0; 		/// reset offset backup because is a child
			chapter_sel_backup = 0; 		/// reset selection backup because is a child
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			//megaupload_return_backup = undefined;
			init_seasons();
			break;
		case "chapters":
			v_screen_ofs = chapter_ofs_backup; 	/// restore backup
			v_screen_sel = chapter_sel_backup; 	/// restore backup
			version_return_backup = undefined;
			version_ofs_backup = 0; 		/// reset offset backup because is a child
			version_sel_backup = 0; 		/// reset selection backup because is a child
			//megaupload_return_backup = undefined;
			init_chapters();
			break;
		case "versions":
			init_versions();
			break;
	}
}

/****************/
/*	Log	*/
/****************/

function log_msg_timeout(count) {
	if (count == log_count) {
		logclear();
	}
}
function log(msg) {
	++log_count;
	if (log_next_clear) {
		log_next_clear = false;
		if (domobj = document.getElementById("info")) domobj.innerHTML = msg;
	} else {
		if (domobj = document.getElementById("info")) domobj.innerHTML = domobj.innerHTML + "<br />" + msg;
	}
	setTimeout(log_msg_timeout, 25000, log_count + 0);
}
function logclear() {
	++log_count;
	if (domobj = document.getElementById("info")) domobj.innerHTML = "";
}
function lognextclear() {
	log_next_clear = true;
}

/****************/
/*	Init	*/
/****************/

function focus_handler() {
	if (domobj = document.getElementById("series")) domobj.style.visibility = "visible";
}

function init(callback) {
	document.addEventListener("keydown", key_handler, true);
	window.addEventListener("focus", focus_handler, true);
	//key_handler();
	init_screen(callback);
	setTimeout(function() {
		if (DEBUG) log(log_init);
		if (DEBUG) log("DEBUG activated");
		//log("Recuerde:");
		setTimeout(function() {
			//log(" - debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.");
			setTimeout(function() {
				//log(" - puede pulsar las teclas num&eacute;ricas para acceder a las letras correspondientes.");
				lognextclear();
			}, 100);
		}, 100);
	}, 100);
}
if ((window.HED) && (HED.ready) && ((typeof HED.ready) == "function")) setTimeout(HED.ready, 100, init); else setTimeout(init, 500); ///< HED can be not defined, init the app in emulation mode in that case