/*======================================================*/
/*======================================================*/
/*	Serieonline for tvalacarta para WebTV	*/
/*======================================================*/
/*======================================================*/

if(DEBUG) log("Cargando plugin Serieonline");

/************************/
/*	Define Plugin	*/
/************************/

var serieonline={
	title: "Serieonline",
	media: ["Series", serieonline_configure_series],
	init:  [serieonline_init_main,   serieonline_init_search,   serieonline_init_series,   serieonline_init_seasons,   serieonline_init_chapters,  serieonline_init_versions],
	load:  [serieonline_cargar_pagina],
	render:[serieonline_render_main, serieonline_render_search, serieonline_render_series, serieonline_render_seasons, serieonline_render_chapters, serieonline_render_versions],
	action:[serieonline_action_main, serieonline_action_search, serieonline_action_series, serieonline_action_seasons, serieonline_action_chapters, serieonline_action_versions],
	focus: [serieonline_render_focus]
};

/********************************/
/*	START of Customization	*/
/********************************/

//Configura busquedas y mensajes para buscar series

function serieonline_configure_series() {
	base_url = "http://www.serieonline.net/";
	estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 99; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.serieonline.net/series/"; // series
	search_categories = /<a href=\"http:\/\/www.serieonline.net\/([^\/]*\/)\">([^<]*)<\/a>/g;  //Series
	search_seasons = /<a href=\"http:\/\/www.serieonline.net\/([^\"]*)\">([^<]*)<\/a><br\/>/g; //Series
	search_versions = /<a href=\"(http:\/\/www.megaupload.com\/[^\"]*)\" target=\"_blank\">(Descargar de megaupload)<\/a><br\/>/g; //series

	url_novelties = "http://www.serieonline.com/"; // series
	
	search_novelties = /<a href=\"([^\"]*)\" title=\"([^\"]*)\">/g;
	//search_novelties = /<a href=\"(http:\/\/www.serieonline.net\/[^\"]*)\" title=\"[^\"]*\"><img src=\"http:\/\/www.serieonline.net\/[^\"]*\" alt=\"([^\"]*)\" class=\"captify\" \/><\/a>/g;

	//url_buscar = "http://www.serieonline.com/buscador/?q="; //Series
	//search_busqueda = /href='(http:\/\/[^\.]*.serieonline.com)'>([^<]*)</g;
                                   
	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay series disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_seasons = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_seasons = "Cargando la pantalla de cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}


/************************/
/*	Main		*/
/************************/

var serieonline_main_list;

//Initialize the behaviour of the main page

function serieonline_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Razon: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			log(log_page_not_found);
			break;
	}
}

function serieonline_search_error_callback() {
	log(log_error_analizing_data + current_url);
	v_loading=false;
}

function serieonline_init_main(){
	//if(DEBUG) log ("Inicializando main");
	list_no_matches_available = no_matches_available_main;
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	HED.helpers.url({url: current_url = url_categories, match: match_current = search_categories, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if(DEBUG) log("Loaded main page");
		//if (this_loading_ref !== v_loading_ref) return;
		serieonline_main_list =new Array();
		serieonline_main_list.push({title: "Novedades", url: ""});
		//serieonline_main_list.push({title: "Buscar", url: ""});
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=6; i<maximum-1; i++) {
			serieonline_main_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
			//log (serieonline_main_list[i-6].url);
			}
		v_visible=14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: serieonline_search_error_callback, cbmx: serieonline_multiplexed_callback});
}

//Renderiza el men de categoras

function serieonline_render_main() {
	list_render(serieonline_main_list,"", "serieonline_");
}

//What to do when OK is pressed under the main menu

function serieonline_action_main() {
	//Destacados
	if ((v_screen_sel==0) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_novelties;
		cathegory_title_backup = "Novedades";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "series";
	}
	else {
		//log(v_screen_sel);
		//log("v_screen_ofs="+v_screen_ofs);
		//log("v_screen_sel="+v_screen_sel);
		cathegory_url_backup = base_url + serieonline_main_list[ v_screen_sel ].url;
		cathegory_title_backup = serieonline_main_list[ v_screen_sel ].title;
		if (DEBUG) log(log_loading_seasons + cathegory_url_backup);
		season_return_backup="main";
		v_screen = "seasons";
	}
}

/************************/
/*	Search		*/
/************************/

//Initialize the behaviour of the search page

function serieonline_init_search(){};

//Renderiza el men de bsqueda

function serieonline_render_search() {};

//What to do when OK is pressed under the search menu

function serieonline_action_search() {};

/************************/
/*	Series		*/
/************************/

var serieonline_series_list;

function serieonline_cargar_pagina() {};

//Initialize the behaviour of the series page

function serieonline_init_series(){
	//if(DEBUG) log ("Inicializando Novedades");
	list_no_matches_available = no_matches_available_main;
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	HED.helpers.url({url: current_url = url_novelties, match: match_current = search_novelties, cbok: function(data) {
		log("FOUND");
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		log(maximum);
		for (var i=0; i<maximum; i++) {
			log(i);
			serieonline_series_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		}
		log("DONE");
		v_visible=14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
	}, cber: serieonline_search_error_callback, cbmx: serieonline_multiplexed_callback});
};

//Renderiza el men de series (Con cartulas)

function serieonline_render_series() {
	list_render(serieonline_series_list,"", "serieonline_");
};

//What to do when OK is pressed under the series menu

function serieonline_action_series() {
		serie_url_backup = serieonline_series_list[ v_screen_sel ].url;
		serie_title_backup = serieonline_series_list[ v_screen_sel ].title;
		if (DEBUG) log(log_loading_seasons + serie_url_backup);
		season_return_backup="series";
		v_screen = "seasons";
};

/************************/
/*	Seasons		*/
/************************/

var serieonline_seasons_list;

//Initialize the behaviour of the seasons page

function serieonline_init_seasons(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	//if ((estructura == "series") && (cathegory_title_backup.search("Buscar: ")==-1)) var url_busqueda = cathegory_url_backup;
	//else var url_busqueda = serie_url_backup;

	var url_busqueda = cathegory_url_backup;
	//if (cathegory_title_backup.search("Destacados")!=-1) var patron_busqueda = search_busqueda;
	//else var patron_busqueda = search_seasons;
	var patron_busqueda = search_seasons;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = patron_busqueda, cbok: function(data) {
		serieonline_seasons_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) {
			serieonline_seasons_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
			
		}
		//serieonline_chapters_datos_imagen = HED.helpers.url({url: current_url, matchnames: ["image"], match: search_image, get: 0, cbmx: serieonline_multiplexed_callback});
		//if (cathegory_title_backup.search("Buscar: ")!=-1) serieonline_chapters_titulo = serie_title_backup;
		//else serieonline_chapters_titulo = cathegory_title_backup;
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: serieonline_search_error_callback, cbmx: serieonline_multiplexed_callback});
}

//Renderiza el men de temporadas

function serieonline_render_seasons() {
	list_render(serieonline_seasons_list,"", "serieonline_");
}

//What to do when OK is pressed under the seasons menu

function serieonline_action_seasons() {
		season_url_backup = base_url + serieonline_seasons_list[ v_screen_sel ].url;
		season_title_backup = serieonline_seasons_list[ v_screen_sel ].title;
		chapter_title_backup = season_title_backup;
		if (DEBUG) log(log_loading_versions + season_url_backup);
		v_screen = "versions";
		version_return_backup="seasons";
}


/************************/
/*	Chapters	*/
/************************/

//Initialize the behaviour of the chapters page


var serieonline_chapters_list;

function serieonline_init_chapters(){
}

//Renderiza el men de captulos

function serieonline_render_chapters() {
}

//What to do when OK is pressed under the chapters menu

function serieonline_action_chapters() {
}

/************************/
/*	Versions	*/
/************************/

//Initialize the behaviour of the versions page

var serieonline_versions_list;

function serieonline_init_versions(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	var url_busqueda = season_url_backup;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = search_versions, cbok: function(data) {
		serieonline_versions_list = new Array();
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) {
			serieonline_versions_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
//			serieonline_versions_list[i].title = "Ver desde Megaupload Mirror "+ (i+1);
		}
		v_visible = 14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: serieonline_search_error_callback, cbmx: serieonline_multiplexed_callback});
}

//Renderiza el men de captulos

function serieonline_render_versions() {

	list_render(serieonline_versions_list,"", "serieonline_");

}

//What to do when OK is pressed under the chapters menu

function serieonline_action_versions() {
	if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
	if ((v_screen_sel_data = HED.helpers.url({get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) {
			version_url_backup = v_screen_sel_data.url;
			megaupload_return_backup="versions";
			v_screen = "megaupload";
			if (domobj = document.getElementById("fields")) domobj.innerHTML = message_getting_information_versions; 
			if (domobj = document.getElementById("title")) domobj.innerHTML = message_getting_information_versions_title;
			if (v_cancel_playback) { v_cancel_playback = false; v_screen = "versions"; init_screen(); return; }
			if (v_screen != "megaupload") return;
			if (DEBUG) log("Reproducir " + v_screen_sel_data.url);
			play_handler(v_screen_sel_data.url);

		}
	}
}


/************************/
/*	Focus Handling	*/
/************************/

function serieonline_render_focus() {
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});	
	if(v_screen=="main") maximum=maximum-7+1;
	if((v_screen == "series") && pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}
	if (v_screen=="search") { 
		//if (DEBUG) log("pagina de busqueda, renderizando foco");
		if (domobj = document.getElementById("write_here")) {
			//if (DEBUG) log("div encontrado");
			domobj.focus();
		}
		else {
			//if (DEBUG) log("no he encontrado el div");
		}
	}
	else {
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel - v_screen_ofs);
		}
	}

	var titulo = "";

	switch (v_screen) {
		case "main":
			if (maximum > 0) titulo = media_title_backup + " / " + "Alfab&eacute;tico " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = media_title_backup + " / " + "Alfab&eacute;tico";
			break;
		case "search":
			titulo = media_title_backup + " / " +"Buscar " + text_to_search;
			break;
		case "series":
			if(pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / ---";
			if(!pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = cathegory_title_backup;
			break;
		case "seasons":
			if (maximum > 0) titulo = media_title_backup + " / " + cathegory_title_backup + " / Cap&iacute;tulos disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "versions":
			if (maximum > 0) titulo = media_title_backup + " / " + cathegory_title_backup + " / " + season_title_backup + " / " + chapter_title_backup + " / Versiones disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
	}
	if (titulo.length>70) titulo = "..." + titulo.slice(titulo.length-70);
	if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
}