if(DEBUG) log("Loading template: cover_matrix");

//Input configuration parameters
var cover_matrix_search_link_pages; 	//The regular expression for searching next pages urls must be defined here
var cover_matrix_search;			//The regular expression for searching contents inside the pages must be defined here
var cover_matrix_matchnames = ["url", "image", "title"]; //identifiers list for the returned matches 
var cover_matrix_title;
var cover_matrix_headers = {'user-agent': 'Mozilla/5.0 (Windows; U; Windows NT 6.1; es-ES; rv:1.9.2.17) Gecko/20110420 Firefox/3.6.17'}; //Firefox user Agent

var cover_matrix_generate_page_url = function (n) { 			//This is justa an example. This function must be redefined for each particular use. 
	return "http://www.algunapaginadeenlaces.com/"+ n +".html";  	//Given a number it must return a string whith the URL correspondig to that particular page number
};

var cover_matrix_check_for_last_page = function(n, url, title) { 	//This is justa an example. This function must be redefined for each particular use. 
	if (title>n) return true;				//Given the number of the current page, and the title and url of the last link found, it must return false if this is the last page or true in any other case
	else return false;
};

//Mesages used in this template. Can be redefined for each particular use if required

var cover_matrix_no_matches_available = "<div class='message'></div>No se han encontrado contenidos.";
var cover_matrix_log_error_analizing_data = "Error analizando datos de ";
var cover_matrix_log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
var cover_matrix_log_error_getting_pages_post = " p&aacute;ginas";

//Pagination variables

var cover_matrix_all_data;		//Data buffer
var cover_matrix_page_number;		//Current page number
var cover_matrix_num_pages; 		//Total number of pages
var cover_matrix_pages_left = true;	//True until the last page is reached, then false
var cover_matrix_maximum = 0;		//Number of elemnts currently availble in the list
var cover_matrix_links_per_page = 0;	//Number of links gatered from each web page

var cover_matrix_style_prefix; 		//Variable for keeping the style prefix, so focus and blur functions can know it

/************************************************/
/*	Returns the n-th elemnt of the list	*/
/************************************************/

function cover_matrix_get_element(n) {
	return HED.helpers.url({url: current_url, match: match_current, matchnames: cover_matrix_matchnames, get: n});
}

/************************/
/*	Error Callbacks	*/
/************************/

function cover_matrix_search_error() {
	log(cover_matrix_log_error_analizing_data + current_url);
	v_loading=false;
}

function cover_matrix_error_loading_page() {
	log(cover_matrix_log_error_analizing_data + current_url);
	v_loading=false;
	--cover_matrix_page_number;
}

function cover_matrix_muxcb_count_pages (reason, args) {
	//if (DEBUG) log("Raz&oacute;n: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			//if (DEBUG) log("Imposible descargar mas paginas");
			if (DEBUG) log(cover_matrix_log_error_getting_pages_pre + num_pages + cover_matrix_log_error_getting_pages_post);
			break;
	}
}

function cover_matrix_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Raz&oacute;n: " + reason);
	//switch (reason) {
	//	case "data-cannot-fetch":
	//		log(log_page_not_found);
	//		break;
	//}
}

/************************************************************************/
/*	Load each page within the index one by one under request	*/
/************************************************************************/

function cover_matrix_load_page(){
	if(cover_matrix_page_number==0) {
		//if(DEBUG) log("Inicializando matriz de car&iacute;tulas");
		cover_matrix_num_pages=0;
		cover_matrix_all_data="";
		cover_matrix_pages_left=true;
	};
	++cover_matrix_page_number;
	if (cover_matrix_pages_left) {
		v_loading=true;
		var page_url = cover_matrix_generate_page_url(cover_matrix_page_number);
		//if (DEBUG) log("Procesando pagina " + page_url);
		HED.helpers.url({url: current_url = page_url, headers: cover_matrix_headers, cbok: function(data) {  
			//if (DEBUG) log("Anadiendo informacion de la pagina " + cover_matrix_page_number);
			cover_matrix_all_data += data;
			//log(data);
			//if (DEBUG) log("Comprobando si es la ultima pagina");
			HED.helpers.url({url: current_url, match: match_current = cover_matrix_search_link_pages, headers: cover_matrix_headers, cbok: function(data) {
				var num_links = HED.helpers.url({url: current_url, match: match_current, headers: cover_matrix_headers, get: "len"})-1;
				//if (DEBUG) log("Numero de anlaces:" + num_links);
				var last_link = HED.helpers.url({url: current_url, match: match_current, headers: cover_matrix_headers, get: num_links});
				//if (DEBUG) log("Procesando pagina:" + cover_matrix_page_number);
				//if (DEBUG) log("Ultimo enlace:" + last_link.title);
				if ((cover_matrix_check_for_last_page(cover_matrix_page_number, last_link.url, last_link.title)) && (num_links>-1)) cover_matrix_pages_left = true;
				else {
					cover_matrix_pages_left = false;
					cover_matrix_num_pages = paged_list_page_number;
					//if (DEBUG) log("Se han encontrado " + cover_matrix_num_pages + " paginas de enlaces");
				}
			}, cber: cover_matrix_search_error, cbmx: cover_matrix_muxcb_count_pages});
			//Busca matches dentro de los datos almacenados
			HED.helpers.url({url: current_url = "main-cache-container-" + cover_matrix_title, data: cover_matrix_all_data, match: match_current = cover_matrix_search, matchnames: cover_matrix_matchnames, headers: cover_matrix_headers, get: "clean"});
			HED.helpers.url({url: current_url = "main-cache-container-" + cover_matrix_title, data: cover_matrix_all_data, match: match_current = cover_matrix_search, matchnames: cover_matrix_matchnames, headers: cover_matrix_headers, cbok: function(data) {
				//Update the number of elemnts currently available in the list
				cover_matrix_maximum = HED.helpers.url({url: current_url, match: match_current, matchnames: cover_matrix_matchnames, headers: cover_matrix_headers, get: "len"});
				//if (DEBUG) log("La lista contiene " + cover_matrix_maximum + " elementos");
				render_screen();
				render_focus();
				v_loading = false;
			}, cber: cover_matrix_search_error, cbmx: cover_matrix_multiplexed_callback});
		}, cber: cover_matrix_error_loading_page, cbmx: cover_matrix_multiplexed_callback});
	}
}

/********************************************************/
/*	Render the list for the currently loaded pages	*/
/********************************************************/

function cover_matrix_render(style_prefix) {
	//var divheight=150;
	//var arrow=26;
	var dumphtml = ""; 
	//style_prefix can be used to redefine the style of the elemnts used in rendering the list. This prefix will be inserted in all CSS class elements used, so the style can be redefined in other CSS files. Please see the list.css file to view all the classes used in this template
	if (style_prefix == undefined) style_prefix = "";
	cover_matrix_style_prefix = style_prefix;
	//v_visible = 14;

	//Calcula el numero de elementos

	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Si no se han cargado aun todas las pginas de enlaces no es posible usar el men de forma cclica (pasar del primero al ltimo)
	if(cover_matrix_pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}

	//Comprueba los lmites
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - (v_screen_sel%v_visible) - (v_visible/2);
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = cover_matrix_no_matches_available;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		var cover;
		//Red arrow
		if (v_screen_ofs > 0) dumphtml += "<div class='" + style_prefix + "arrow_cover_matrix " + style_prefix + "redarrow_cover_matrix'>&#9650;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_cover_matrix'></div>";
		//Aade el contenedor para la matriz de cartulas
		dumphtml += "<div class='"+ style_prefix + "matrixcontainer_cover_matrix'>";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			var tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i, matchnames: cover_matrix_matchnames});
			cover = (tmp_data === false) ? "" : (tmp_data.image ? tmp_data.image : "");
			description = (tmp_data === false) ? "" : (tmp_data.title ? tmp_data.title : "");
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			if (i+v_screen_ofs<maximum) dumphtml += "<div class='" + style_prefix + "matrixelementdiv_cover_matrix' id='matrixelement" + i + "'><img src='"+cover+"' class='" + style_prefix + "coverimage_cover_matrix' /><a href='#' id='element" + i + "' class='" + style_prefix + "element_cover_matrix'> " + description + "</a></div>";
		}
		//Cierra el contenedor de la matriz de cartulas
		dumphtml += "</div>";
		//Blue Arow
		if (v_screen_ofs < cover_matrix_maximum - v_visible) dumphtml += "<div class='" + style_prefix + "arrow_cover_matrix " + style_prefix + "bluearrow_cover_matrix'>&#9660;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_cover_matrix'></div>";
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

/************************/
/*	Focus Handling	*/
/************************/

function cover_matrix_focus_div(divid) {
	if (domobj = document.getElementById("element" + divid)) {
		domobj.focus();
		if (domobj = document.getElementById("matrixelement" + divid)) domobj.className= cover_matrix_style_prefix + "matrixelementdiv_cover_matrix_focused";
	};
}

function cover_matrix_blur_div(divid) {
	if (domobj = document.getElementById("element" + divid)) {
		domobj.blur();
		if (domobj = document.getElementById("matrixelement" + divid)) domobj.className= cover_matrix_style_prefix + "matrixelementdiv_cover_matrix";
	}
}

/************************/
/*	Input Handling	*/
/************************/

function cover_matrix_key_handler(e) {
	if(!v_loading) switch (e.keyCode) {
		case 37: ///< LEFT
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			--v_screen_sel;
			if(v_screen_sel<v_screen_ofs) {
				v_screen_ofs=v_screen_ofs-7;
				render_screen();
			}
			render_focus();
			break;
		case 38: ///< UP
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			v_screen_sel=v_screen_sel-7;
			if(v_screen_sel<v_screen_ofs) {
				v_screen_ofs=v_screen_ofs-7;
				render_screen();
			}
			render_focus();
			break;
		case 39: ///< RIGHT
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			++v_screen_sel;
			if(v_screen_sel>v_screen_ofs+v_visible-1) {
				v_screen_ofs=v_screen_ofs+7;
				if((v_screen=="series") && (v_screen_ofs>=(cover_matrix_links_per_page*cover_matrix_page_number)-14) && cover_matrix_pages_left ) cover_matrix_load_page();
				else {
					render_screen();
					render_focus();
				}
			}
			else render_focus();
			break;
		case 40: ///< DOWN
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			v_screen_sel=v_screen_sel+7;
			if(v_screen_sel>v_screen_ofs+v_visible-1) {
				v_screen_ofs=v_screen_ofs+7;
				if((v_screen_ofs>=(cover_matrix_links_per_page*cover_matrix_page_number)-14) && cover_matrix_pages_left ) cover_matrix_load_page();
				else {
					render_screen();
					render_focus();
				}
			}
			else render_focus();
			break;
		case 33: case 114: ///< PREVPG and RED
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				v_screen_sel -= v_visible;
				if(v_screen=="main") v_screen_sel--;
				v_screen_ofs -= v_visible;
				render_screen();
				render_focus();
			}
			break;
		case 34: case 117: ///< NEXTPG and BLUE
			if(((!cover_matrix_pages_left) && (v_screen_ofs >= HED.helpers.url({url: current_url, match: match_current, get: "len"})-v_visible)) ||
			   ((v_screen_ofs >= HED.helpers.url({url: current_url, match: match_current, get: "len"})-v_visible))) break;
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			v_screen_sel += v_visible;
			v_screen_ofs += v_visible;
			if((v_screen_ofs>=(cover_matrix_links_per_page*cover_matrix_page_number)-14) && cover_matrix_pages_left ) cover_matrix_load_page();
			else {
				render_screen();
				render_focus();
			}
			break;
		case 116: case 188: ///< YELLOW
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				v_screen_sel -= v_visible * 4;
				if(v_screen=="main") v_screen_sel--;
				v_screen_ofs -= v_visible * 4;
				render_screen();
				render_focus();
			}
			break;
		case 115: case 190: ///< GREEN
			if(((!cover_matrix_pages_left) && (v_screen_ofs >= HED.helpers.url({url: current_url, match: match_current, get: "len"})-v_visible)) ||
			   ((v_screen_ofs >= HED.helpers.url({url: current_url, match: match_current, get: "len"})-v_visible))) break;
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			if (links_per_page<v_visible * 4) v_screen_sel += v_visible;
			else v_screen_sel += v_visible * 4;
			if (links_per_page<v_visible * 4) v_screen_ofs += v_visible;
			else v_screen_ofs += v_visible * 4;
			if((v_screen_ofs>=(cover_matrix_links_per_page*cover_matrix_page_number)-14) && cover_matrix_pages_left ) {
				//if(v_loading) break
				cover_matrix_load_page();
			}
			else {
				render_screen();
				render_focus();
			}
			break;
	}
}

