if(DEBUG) log("Loading template: paged_list");

//Input configuration parameters
var paged_list_search_link_pages; 	//The regular expression for searching next pages urls must be defined here
var paged_list_search;			//The regular expression for searching contents inside the pages must be defined here
var paged_list_title;
var paged_list_headers = {'user-agent': 'Mozilla/5.0 (Windows; U; Windows NT 6.1; es-ES; rv:1.9.2.17) Gecko/20110420 Firefox/3.6.17'}; //Firefox user Agent

var paged_list_generate_page_url = function (n) { 			//This is justa an example. This function must be redefined for each particular use. 
	return "http://www.algunapaginadeenlaces.com/"+ n +".html";  	//Given a number it must return a string whith the URL correspondig to that particular page number
};

var paged_list_check_for_last_page = function(n, url, title) { 	//This is justa an example. This function must be redefined for each particular use. 
	if (title>n) return true;				//Given the number of the current page, and the title and url of the last link found, it must return false if this is the last page or true in any other case
	else return false;
};

//Mesages used in this template. Can be redefined for each particular use if required

var paged_list_no_matches_available = "<div class='message'></div>No se han encontrado contenidos.";
var paged_list_log_error_analizing_data = "Error analizando datos de ";
var paged_list_log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
var paged_list_log_error_getting_pages_post = " p&aacute;ginas";

//Pagination variables

var paged_list_all_data;		//Data buffer
var paged_list_page_number;		//Current page number
var paged_list_num_pages; 		//Total number of pages
var paged_list_pages_left = true;		//True until the last page is reached, then false
var paged_list_maximum = 0;		//Number of elemnts currently availble in the list
var paged_list_links_per_page = 0;	//Number of links gatered from each web page

/************************************************/
/*	Returns the n-th elemnt of the list	*/
/************************************************/

function paged_list_get_element(n) {
	return HED.helpers.url({url: current_url, match: match_current, get: n});
}


/************************/
/*	Error Callbacks	*/
/************************/

function paged_list_search_error() {
	log(paged_list_log_error_analizing_data + current_url);
	v_loading=false;
}

function paged_list_error_loading_page() {
	log(paged_list_log_error_analizing_data + current_url);
	v_loading=false;
	--paged_list_page_number;
}

function paged_list_muxcb_count_pages (reason, args) {
	//if (DEBUG) log("Raz&oacute;n: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			//if(paged_list_num_pages==undefined) paged_list_num_pages=1;
			//if (DEBUG) log("Imposible descargar mas paginas");
			if (DEBUG) log(paged_list_log_error_getting_pages_pre + num_pages + paged_list_log_error_getting_pages_post);
			//if (DEBUG) log("Procesando " + paged_list_num_pages + " paginas para " + cathegory_url_backup);
			//paged_list_all_data = "";
			//paged_list_page_number = 0;
			//paged_list_load_page(); 
			break;
	}
}

function paged_list_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Raz&oacute;n: " + reason);
	//switch (reason) {
	//	case "data-cannot-fetch":
	//		log(log_page_not_found);
	//		break;
	//}
}



/************************************************************************/
/*	Load each page within the index one by one under request	*/
/************************************************************************/

function paged_list_load_page(){
	if(paged_list_page_number==0) {
		//if(DEBUG) log("Inicializando lista paginada");
		paged_list_num_pages=0;
		paged_list_all_data="";
		paged_list_pages_left=true;
	};
	++paged_list_page_number;
	if (paged_list_pages_left) {
		v_loading=true;
		var page_url = paged_list_generate_page_url(paged_list_page_number);
		//if (DEBUG) log("Procesando pagina " + page_url);
		HED.helpers.url({url: current_url = page_url, headers: paged_list_headers, cbok: function(data) {  
			//if (DEBUG) log("Anadiendo informacion de la pagina " + paged_list_page_number);
			paged_list_all_data += data;
			//log(data);
			//if (DEBUG) log("Comprobando si es la ultima pagina");
			HED.helpers.url({url: current_url, match: match_current = paged_list_search_link_pages, headers: paged_list_headers, cbok: function(data) {
				var num_links = HED.helpers.url({url: current_url, match: match_current, headers: paged_list_headers, get: "len"})-1;
				//if (DEBUG) log("Numero de anlaces:" + num_links);
				var last_link = HED.helpers.url({url: current_url, match: match_current, headers: paged_list_headers, get: num_links});
				//if (DEBUG) log("Procesando pagina:" + paged_list_page_number);
				//if (DEBUG) log("Ultimo enlace:" + last_link.title);
				if ((paged_list_check_for_last_page(paged_list_page_number, last_link.url, last_link.title)) && (num_links>-1)) paged_list_pages_left = true;
				else {
					paged_list_pages_left = false;
					paged_list_num_pages = paged_list_page_number;
					//if (DEBUG) log("Se han encontrado " + paged_list_num_pages + " paginas de enlaces");
				}
			}, cber: paged_list_search_error, cbmx: paged_list_muxcb_count_pages});
			//Busca matches dentro de los datos almacenados
			HED.helpers.url({url: current_url = "main-cache-container-" + paged_list_title, data: paged_list_all_data, match: match_current = paged_list_search, headers: paged_list_headers, get: "clean"});
			HED.helpers.url({url: current_url = "main-cache-container-" + paged_list_title, data: paged_list_all_data, match: match_current = paged_list_search, headers: paged_list_headers, cbok: function(data) {
				//Update the number of elemnts currently available in the list
				paged_list_maximum = HED.helpers.url({url: current_url, match: match_current, headers: paged_list_headers, get: "len"});
				//if (DEBUG) log("La lista contiene " + paged_list_maximum + " elementos");
				render_screen();
				render_focus();
				v_loading = false;
			}, cber: paged_list_search_error, cbmx: paged_list_multiplexed_callback});
		}, cber: paged_list_error_loading_page, cbmx: paged_list_multiplexed_callback});
	}
}

/********************************************************/
/*	Render the list for the currently loaded pages	*/
/********************************************************/

function paged_list_render(heading, style_prefix) {
	var dumphtml = "";
	//heading can be used to insert any HTML code as a heading for the list rendering
	if (heading!=undefined) dumphtml += heading;
	//style_prefix can be used to redefine the style of the elemnts used in rendering the list. This prefix will be inserted in all CSS class elements used, so the style can be redefined in other CSS files. Please see the list.css file to view all the classes used in this template
	if (style_prefix == undefined) style_prefix = "";
	//v_visible = 14;

	//If all pages were not loaded yet, it is not possible to go from the first elemnt to the last by pressing UP
	if(pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= paged_list_maximum) v_screen_sel = paged_list_maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = paged_list_maximum - 1;
		if (v_screen_sel >= paged_list_maximum) v_screen_sel = 0;
	}

	//Check cursor indexes are not outside the scope of the current list
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//If no elemnts are available in the list, show an error
	if (paged_list_maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = paged_list_no_matches_available;}, 250);
	} else { //And if there are any, render the menu
		var description;
		//Red arrow
		if (v_screen_ofs > 0) dumphtml += "<div class='" + style_prefix + "arrow_paged_list " + style_prefix + "redarrow_paged_list'>&#9650;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_paged_list'></div>";
		//Main loop for showing all available elements
		for (var i = 0; i < v_visible; i++) {
			if (v_screen_ofs + i < paged_list_maximum) {
				//Read the data from the match number i
				var v_screen_tmp = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i});
				//if (DEBUG) log("Incluyendo " + v_screen_tmp.title);
				description = (v_screen_tmp === false) ? "" : (v_screen_tmp.title ? v_screen_tmp.title : "");
				//Add elemnt number i to the menu
				dumphtml += "<div class='" + style_prefix + "elementdiv_paged_list'><a href='#' id='element" + i + "' class='" + style_prefix + "element_paged_list'>" + description + "</a></div>";
			}
		}
		//Blue arrow
		if (v_screen_ofs < paged_list_maximum - v_visible) dumphtml += "<div class='" + style_prefix + "arrow_paged_list " + style_prefix + "bluearrow_paged_list'>&#9660;</div>"; else dumphtml += "<div class='" + style_prefix + "noarrow_paged_list'></div>";
	}
	//Rendering is ready, show the menu
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

/************************/
/*	Focus Handling	*/
/************************/

function paged_list_focus_div(divid) {
	if (domobj = document.getElementById("element" + divid)) domobj.focus();
}

function paged_list_blur_div(divid) {
}


/************************/
/*	Input Handling	*/
/************************/

function paged_list_key_handler(e) {
	if(!v_loading) switch (e.keyCode) {
		case 38: ///< UP
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			--v_screen_sel;
			if(v_screen_sel<v_screen_ofs) render_screen();
			render_focus();
			break;
		case 40: ///< DOWN
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			++v_screen_sel;
			if(v_screen_sel>=v_screen_ofs+v_visible) {
				if((v_screen_ofs>=(paged_list_links_per_page*paged_list_page_number)-v_visible) && paged_list_pages_left ) paged_list_load_page();
				else {
					render_screen();
					render_focus();
				}
			}
			else render_focus();
			break;
		case 33: case 114: ///< PREVPG and RED
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				v_screen_sel -= v_visible;
				//v_screen_sel--;
				v_screen_ofs -= v_visible;
				render_screen();
				render_focus();
			}
			break;
		case 34: case 117: ///< NEXTPG and BLUE
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			v_screen_sel += v_visible;
			//v_screen_sel+=2;
			v_screen_ofs += v_visible;
			if((v_screen_ofs>=(paged_list_links_per_page*paged_list_page_number)-v_visible) && paged_list_pages_left ) paged_list_load_page();
			else {
				render_screen();
				render_focus();
			}
			break;
		case 116: case 188: ///< YELLOW
			if(v_screen_ofs>0) {
				v_screen_sel_last=v_screen_sel;
				v_screen_ofs_last=v_screen_ofs;
				if (paged_list_links_per_page<v_visible * 4) {
					if (paged_list_links_per_page<v_visible * 3) {
						if (paged_list_links_per_page<v_visible * 2) {
							v_screen_sel -= v_visible;
							v_screen_ofs -= v_visible;
						}
						else {
							v_screen_sel -= v_visible * 2;
							v_screen_ofs -= v_visible * 2;
						}
					}
					else {
						v_screen_sel -= v_visible * 3;
						v_screen_ofs -= v_visible * 3;
					}
				}
				else {
					v_screen_sel -= v_visible * 4;
					v_screen_ofs -= v_visible * 4;
				}
				render_screen();
				render_focus();
			}
			break;
		case 115: case 190: ///< GREEN
			v_screen_sel_last=v_screen_sel;
			v_screen_ofs_last=v_screen_ofs;
			if (paged_list_links_per_page<v_visible * 4) {
				if (paged_list_links_per_page<v_visible * 3) {
					if (paged_list_links_per_page<v_visible * 2) {
						v_screen_sel += v_visible;
						v_screen_ofs += v_visible;
					}
					else {
						v_screen_sel += v_visible * 2;
						v_screen_ofs += v_visible * 2;
					}
				}
				else {
					v_screen_sel += v_visible * 3;
					v_screen_ofs += v_visible * 3;
				}
			}
			else {
				v_screen_sel += v_visible * 4;
				v_screen_ofs += v_visible * 4;
			}
			if((v_screen_ofs>=(paged_list_links_per_page*paged_list_page_number)-v_visible) && paged_list_pages_left ) paged_list_load_page();
			else {
				render_screen();
				render_focus();
			}
			break;
		default:
			//if (DEBUG) log(log_unhandled_key + e.keyCode);
			break;
	}
	//e.stopPropagation();
}

